
// Simple Demo using THyper64, Window display

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Hyper64; // Add Hyper64.pas to the library list

type
  TForm1 = class(TForm)
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    // Define FormIdle
    // This func will contain the loop code
    // to be ran in the background
    procedure FormIdle(Sender: TObject; var Done : Boolean);
  private
    { Private declarations }
  public
    Hyper : THyper64; // Define our THyper64 object
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormActivate(Sender: TObject);
begin
  // Start by
  // Creating a Hyper object assigned
  // to TForm1.Handle wich points to our window
  Hyper:= THyper64.Create(Handle, 640, 480);

  // Assign our loop func to our
  // application idle process
  Application.OnIdle:= FormIdle;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Free Memory in the end
  Hyper.Destroy;
end;

// This func will contain the loop code
// to be ran in the background
procedure TForm1.FormIdle(Sender: TObject; var Done : Boolean);
begin
  // Fill Window with a random color
  Hyper.Fill(random(65536));
  Sleep(500); // Stop process for half second

  Done:= false; // Loop again
end;

end.
 