// To compile this program on Delphi's IDE you must Open this file
// as "Pascal project (*.pas)"

// This is the as simple as Hyper64 can get, wich i think is not
// too complicated, there should be no problem because it's well commented.

// This test just opens a image file, a PNG
// file in this case and just draws it in the last mouse position
// captured by Hyper64 Mouse event handler.
// The program runs until the window is forced to close
// or the ESCAPE key is pressed.

// NOTE Key[] and Mouse.* ONLY WORK when using TSelfHyper64

{$D-,L-}
{$APPTYPE GUI}

program SelfHyper;

// Add Hyper64.pas to the Library list
uses Hyper64;

var
  // Define Objects
  Screen : TSelfHyper64;
  Buffer,
  Image  : TBuffer64;

begin
  // Create a TSelfHyper64
  // the last parameter is the desired name for
  // the window to be created, it identifies your program 
  Screen:= TSelfHyper64.Create(640, 480, 'Self Test');
  // Create a back Buffer 
  Buffer:= TBuffer64.Create(Screen, 640, 480, true);
  // Just create a Image buffer to store
  // the future image, the size is 1x1 because
  // there is no need to have a bigger buffer
  // since the buffer size will be resized when you load
  // the image
  Image:= TBuffer64.Create(Screen, 1, 1, true);

  // Load the desired image
  Image.LoadImage('images\face.png', true);

  // TSelfHyper64.DoEvents takes care of the WinAPI
  // stuff for you, when it returns FALSE, it means
  // that windows is requesting the end of the program
  // so you should have this procedure running and checking
  // whenever is possible

  // Keys[VK_ESCAPE]:= true?  ESC key is down (pressed)
  // Keys[VK_ESCAPE]:= false? ESC key is up   (released)

  // Repeat while program is running and ESC key is up (not pressed) 
  while Screen.DoEvents and not keys[VK_ESCAPE] do begin

    // Copy the Image to the back Buffer in the
    // last (current) Mouse position
    Image.Copy(Buffer, Mouse.X, Mouse.Y);

    // Draw the back Buffer to the Screen
    Buffer.Flip(true);
  end;

  // Free all memory
  Image.Destroy;
  Buffer.Destroy;
  Screen.Destroy;
end.
