unit Unit1;

interface

uses
  Windows, SysUtils, Forms, ExtCtrls, Classes, Controls, StdCtrls, Hyper64;

type
  TForm1 = class(TForm)
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OnIdle(Sender : TObject; var Done : Boolean);
    procedure FormClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1    : TForm1;
  Hyper    : THyper64;
  Buffer   : TBuffer64;
  Buffer2  : TBuffer64;

implementation

{$R *.DFM}

procedure TForm1.OnIdle(Sender : TObject; var Done : Boolean);
var
  x, y : LongInt;
  c1, c2, c3, c4 : longint;
begin
  if Buffer.Bitpp= 16 then begin
    for y:= 1 to Buffer.YMax- 1 do
      for x:= 1 to Buffer.XMax- 1 do begin
        c1:= Buffer.Pixels16[y+ 1][x];
        c2:= Buffer.Pixels16[y- 1][x];
        c3:= Buffer.Pixels16[y][x+ 1];
        c4:= Buffer.Pixels16[y][x- 1];
        Buffer.Pixels16[y][x]:= (c1+ c2+ c3+ c4) shr 2;
      end;
  end
  else begin
    for y:= 1 to Buffer.YMax- 1 do
      for x:= 1 to Buffer.XMax- 1 do begin
        c1:= Buffer.GetPixel(x, y+ 1);
        c2:= Buffer.GetPixel(x, y- 1);
        c3:= Buffer.GetPixel(x+ 1, y);
        c4:= Buffer.GetPixel(x- 1, y);
        Buffer.PutPixel(x, y, (c1+ c2+ c3+ c4) shr 2);
      end;
  end;

  Buffer.Flip(false);
  Done:= False;
end;

procedure TForm1.FormActivate(Sender: TObject);
var x, y : LongInt;
begin
  Hyper:= THyper64.Create(Handle, 400, 300);
  Buffer:= TBuffer64.Create(Hyper, Hyper.XSize, Hyper.YSize, false);
  Buffer2:= TBuffer64.Create(Hyper, 40, 40, false);

  Left:= (GetSystemMetrics(SM_CXSCREEN) shr 1)- (Buffer.XSize shr 1);
  Top:= (GetSystemMetrics(SM_CYSCREEN) shr 1)- (Buffer.YSize shr 1)+ 10;

  Buffer2.FillCircle(20, 20, 10, RGB(255, 255, 255));

  Application.OnIdle:= OnIdle;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Buffer2.Destroy;
  Buffer.Destroy;
  Hyper.Destroy;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  Buffer.SaveTGA('test.tga');
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  Buffer2.CopySprite(Buffer, x- 20, y- 20, 0);
end;

end.
