
program Bump;

uses Hyper64;

type
  TPoint = record
    X, Y : LongInt;
  end;

var
  Scr      : THyper64;
  Buf,
  BumpMap,
  PhongMap : TBuffer64;
  X, Y     : LongInt;
  Color    : Byte;
  LX, LY   : LongInt;
  NX, NY   : LongInt;
  Light    : TPoint;
  a, b, c, d, t : byte;
begin
  Scr:= TSelfFullHyper64.Create(320, 200, 16, 'Bump');
  Buf:= TBuffer64.Create(Scr, 320, 200, false);

  BumpMap:= TBuffer64.Create(Scr, 1, 1, false);
  PhongMap:= TBuffer64.Create(Scr, 1, 1, false);

  BumpMap.LoadImage('images\BumpMap.png', false);
  PhongMap.LoadImage('images\PhongMap.png', false);

  while Scr.DoEvents and (not Keys[VK_ESCAPE]) and (not Keys[VK_RETURN]) do begin
    Light.X:= Mouse.X;
    Light.Y:= Mouse.Y;
    for y:= 1 to 198 do
      for x:= 1 to 318 do begin
        UnRGB(BumpMap.Pixels16[y, x+ 1], a, a, a);
        UnRGB(BumpMap.Pixels16[y, x- 1], b, b, b);
        UnRGB(BumpMap.Pixels16[y+ 1, x], c, c, c);
        UnRGB(BumpMap.Pixels16[y- 1, x], d, d, d);
        NX:= a- b;
        NY:= c- d;

        LX:= x- Light.X;
        LY:= y- Light.Y;
        Dec(NX, LX);
        Dec(NY, LY);

        Inc(NX, 92);
        Inc(NY, 92);

        if (NX> 191) or (NX< 0) then NX:= 0;
        if (NY> 191) or (NY< 0) then NY:= 0;

        Buf.Pixels16[y, x]:= PhongMap.GetPixel(NX, NY);
      end;

    Buf.Flip(false);
  end;
  
  BumpMap.Destroy;
  PhongMap.Destroy;
  Buf.Destroy;
  Scr.Destroy;
end.