{
   Copyright (C) 2000 Diogo Teixeira FoZi_B@yahoo.com

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.

  - Hyper64 -
    Copyright Diogo Teixeira aka FoZi
    FoZi_B@yahoo.com
    http://whatsNext.hyper32.net/
  - Hyper64 -

  !This version is directed for tests only!

  See history at the bottom of this file
}

// DirectX version target. Enable Only ONE of these!
{$DEFINE DX3} // WinNT SP3+       (+Win95/98/2k)
{ $DEFINE DX6} // Win95            (Win98/2k)
{ $DEFINE DX7} // Win98/WinME/Win2k

// Safety checks
{$IFNDEF DX3}
{$IFNDEF DX6}
{$IFNDEF DX7}
ATTENTION!!! You must select one of DirectX target version!
{$ENDIF}
{$ENDIF}
{$ENDIF}

{$A+,D-,I-,L-,R-}

unit Hyper64;

interface

uses Windows, DirectDraw;

const H64_VERSION = $B04;

const
  // Timer Formats
  tfSec      = $F0; { 1/1       seconds }
  tfMiliSec  = $F1; { 1/1000    seconds }
  tfMicroSec = $F2; { 1/1000000 seconds }

type
  // Color Triplets
  TBGR = record
    B, G, R : Byte;
  end;

  // ScanLine Pointers
  // Main Def
  TLine   = array [Word] of Pointer;
  PLine   = ^TLine;
  // Secondary Defs
  TLine8  = array [Word] of byte;
  PLine8  = ^TLine8;
  TLine16 = array [Word] of Word;
  PLine16 = ^TLine16;
  TLine24 = array [Word] of TBGR;
  PLine24 = ^TLine24;
  TLine32 = array [Word] of LongWord;
  PLine32 = ^TLine32;

  // Pixel Pointers
  TPixel8  = array [Word] of PLine8;
  PPixel8  = ^TPixel8;
  TPixel16 = array [Word] of PLine16;
  PPixel16 = ^TPixel16;
  TPixel24 = array [Word] of PLine24;
  PPixel24 = ^TPixel24;
  TPixel32 = array [Word] of PLine32;
  PPixel32 = ^TPixel32;

  // Edge Info
  TEdge = array [0..1, Word] of LongInt;
  PEdge = ^TEdge;

  TRGBEdge = array [0..1, Word] of record
    R, G, B : LongInt;
  end;
  PRGBEdge = ^TRGBEdge;

	TTexEdge = array [0..1, Word] of record
	  U, V : LongInt;
	end;
	PTexEdge = ^TTexEdge;

  // Vertex Definition
  TVertex = record
    X, Y, Z,
    U, V, W : Single;
    Color   : LongWord;
  end;

  PHyper64 = ^THyper64;
  THyper64 = class
      Handle : HWnd;

      XSize,
      YSize,
      XMid,
      YMid,
      XMax,
      YMax  : LongInt;
      Bitpp : Byte;

      // Event handler (TSelfHyper64 and TSelfFullHyper64)
      function DoEvents : Boolean;

      // Set Window Pos (TSelfHyper64 and TSelfFullHyper64)
      procedure SetWindowPos(XPos, YPos : LongInt);

      // Clear
      procedure Fill(color : LongWord);
      procedure FillBack(color : LongWord);

      // Setup
      constructor Create(h_Wnd : HWnd; SizeX, SizeY : LongInt);
      destructor Destroy; override;

    private
      {$IFDEF DX3}
      DDObject  : IDirectDraw;
      DDPrimary : IDirectDrawSurface;
      DDBackSurface : IDirectDrawSurface;
      {$ENDIF}
      {$IFDEF DX6}
      DDObject  : IDirectDraw4;
      DDPrimary : IDirectDrawSurface4;
      DDBackSurface : IDirectDrawSurface4;
      {$ENDIF}
      {$IFDEF DX7}
      DDObject  : IDirectDraw7;
      DDPrimary : IDirectDrawSurface7;
      DDBackSurface : IDirectDrawSurface7;
      {$ENDIF}
      DDClipper : IDirectDrawClipper;

      IsFull    : Boolean;

      // Tools
      procedure err_MSG(Source, ErrMsg : String);
      function  GlobalBpp : integer;
      procedure FreeAll;

      // DirectDraw
      procedure InitAll(FullScreen : Boolean);
      procedure ReleaseAll;
      procedure RestoreAll;

  end;

  PFull64 = ^TFullHyper64;
  TFullHyper64 = class(THyper64)

    constructor Create(h_Wnd : HWnd; SizeX, SizeY, Bpp : LongInt);
    destructor Destroy; override;

    private

    procedure err_MSG(Source, ErrMsg : String);
  end;

  PSelf64 = ^TSelfHyper64;
  TSelfHyper64 = class(THyper64)

    constructor Create(SizeX, SizeY : LongInt; UserTitle : PChar);
    destructor Destroy; override;

    private

    h_Instance : HInst;
    Title : PChar;

    procedure err_MSG(Source, ErrMsg : String);
  end;

  PSelfFull64 = ^TSelfFullHyper64;
  TSelfFullHyper64 = class(THyper64)

    constructor Create(SizeX, SizeY, Bpp : LongInt; UserTitle : PChar);
    destructor Destroy; override;

    private

    h_Instance : HInst;
    Title : PChar;

    procedure err_MSG(Source, ErrMsg : String);
  end;

  PBuffer64 = ^TBuffer64;
  TBuffer64 = class
      AlphaPtr : Pointer;
      Ptr      : Pointer;
      XSize,
      YSize,
      XMid,
      YMid,
      XMax,
      YMax,

      Bpsl   : LongInt;
      Bytepp : Byte;
      Bitpp  : Byte;

      Lines    : PLine;
      Pixels8  : PPixel8;
      Pixels16 : PPixel16;
      Pixels24 : PPixel24;
      Pixels32 : PPixel32;

      AlphaLines  : PLine;
      AlphaPixels : PPixel8;

      // Primitives
      procedure Fill(color : LongWord);
      procedure PutPixel(x, y : LongInt; color : LongWord);
      function  GetPixel(x, y : LongInt) : LongWord;
      procedure Line(x1, y1, x2, y2 : LongInt; color : LongWord);
      procedure HLine(x1, x2, y : LongInt; color : LongWord);
      procedure VLine(y1, y2, x : LongInt; color : LongWord);
      procedure Rect(x1, y1, x2, y2 : LongInt; color : LongWord);
      procedure FillRect(x1, y1, x2, y2 : LongInt; color : LongWord);
      procedure Circle(x, y, r : LongInt; color : LongWord);
      procedure FillCircle(x, y, r : LongInt; color : LongWord);
      procedure Ellipse(x, y, rx, ry : LongInt; color : LongWord);
      procedure FillEllipse(x, y, rx, ry : LongInt; color : LongWord);
      procedure CubicBezierLine(x1, y1, x2, y2, c1x, c1y, c2x, c2y,
                                segments : LongInt; color : LongWord);

      // Blitting
      procedure Draw(x, y : LongInt);
      procedure DrawSprite(x, y : LongInt; key : LongWord);
      procedure DrawBit(x1, y1, x2, y2, x, y : LongInt);
      procedure DrawBitSprite(x1, y1, x2, y2, x, y : LongInt; key : LongWord);

      procedure Copy(Buffer : TBuffer64; x, y : LongInt);
      procedure CopySprite(Buffer : TBuffer64; x, y : LongInt; key : LongWord);
      procedure CopyBit(Buffer : TBuffer64; x1, y1, x2, y2, x, y : LongInt);
      procedure CopyBitSprite(Buffer : TBuffer64; x1, y1, x2, y2, x, y : LongInt; key : LongWord);

      // GFX
      procedure DrawScale(x1, y1, x2, y2 : LongInt);
      procedure DrawScaleSprite(x1, y1, x2, y2 : LongInt; key : LongWord);

      procedure CopyScale(Buffer : TBuffer64; x1, y1, x2, y2 : LongInt);
      procedure CopyScaleSprite(Buffer : TBuffer64; x1, y1, x2, y2 : LongInt; key : LongWord);

      procedure CopyRotate(Buffer : TBuffer64; cx, cy : LongInt; scale, angle : Single);
      procedure CopyRotateSprite(Buffer : TBuffer64; cx, cy : LongInt;
                                 scale, angle : Single; key : LongWord);

      procedure ShadedRect(x1, y1, x2, y2 : LongInt;
                           topleft_color, topright_color,
                           botleft_color, botright_color : LongWord);

      procedure CopyAlpha(Buffer : TBuffer64; x, y : LongInt; alpha : byte);
      procedure CopyAlphaMap(Buffer : TBuffer64; x, y : LongInt);
      procedure CopyAlphaSprite(Buffer : TBuffer64; x, y : LongInt; alpha : byte; key : longword);
      procedure CopyAdd(Buffer : TBuffer64; x, y : LongInt);
      procedure CopySub(Buffer : TBuffer64; x, y : LongInt);
      procedure CopyXor(Buffer : TBuffer64; x, y : LongInt);

      // Extract RGBA components
      procedure CopyRedChannel(Buffer : TBuffer64; x, y : LongInt);
      procedure CopyGreenChannel(Buffer : TBuffer64; x, y : LongInt);
      procedure CopyBlueChannel(Buffer : TBuffer64; x, y : LongInt);
      procedure CopyAlphaChannel(Buffer : TBuffer64; x, y : LongInt);

      // Filters
      procedure Blur2x;
      procedure Negative;
      procedure Greyscale;
                           
      // Flipping
      procedure Flip(VSync : Boolean);

      // Image Loading
      procedure GetImageSize(filename : string; var sizex, sizey : LongInt);
      procedure LoadImage(filename : string; VideoMem : Boolean);
      procedure LoadAlpha(filename : string);
      procedure SaveTGA(filename : string);

      // Text
      procedure WriteStr(x, y : LongInt; Text : String; color : LongWord);

      // Setup
      constructor Create(Hyper : THyper64; SizeX, SizeY : LongInt; VideoMem : Boolean);
      destructor Destroy; override;

      // Internal Use
      procedure FlatPoly(VertexList : array of TVertex; NumVertex : LongInt; color : LongWord);
      procedure GouraudPoly(VertexList : array of TVertex; NumVertex : LongInt);
      procedure TexturePoly(Texture : TBuffer64; VertexList : array of TVertex; NumVertex : LongInt);
      procedure KeyTexturePoly(Texture : TBuffer64; VertexList : array of TVertex;
                               NumVertex : LongInt; key : LongWord);

    private
      Handle  : HWnd;

      hXSize, hYSize, hBpp : LongInt;
      {$IFDEF DX3}
      DDObject  : IDirectDraw;
      DDPrimary : IDirectDrawSurface;
      DDBackSurface : IDirectDrawSurface;
      DDSurface   : IDirectDrawSurface;
      DDSurfaceDp : TDDSurfaceDesc;
      {$ENDIF}
      {$IFDEF DX6}
      DDObject  : IDirectDraw4;
      DDPrimary : IDirectDrawSurface4;
      DDBackSurface : IDirectDrawSurface4;
      DDSurface   : IDirectDrawSurface4;
      DDSurfaceDp : TDDSurfaceDesc2;
      {$ENDIF}
      {$IFDEF DX7}
      DDObject  : IDirectDraw7;
      DDPrimary : IDirectDrawSurface7;
      DDBackSurface : IDirectDrawSurface7;
      DDSurface   : IDirectDrawSurface7;
      DDSurfaceDp : TDDSurfaceDesc2;
      {$ENDIF}

      usesAlpha : boolean;

      IsFull  : Boolean;

      XEdge   : TEdge;
      RGBEdge : TRGBEdge;
      TexEdge : TTexEdge;

      // Tools
      procedure err_MSG(Source, ErrMsg : String);
      procedure FreeAll;

      // DirectDraw
      procedure RestoreAll;

      // DirectDraw Surface
      procedure Lock;
      procedure UnLock;

      // Blitting
      procedure FlipBackToPrimary;

      // Clipping
      function  ClipLine(var x1, y1, x2, y2 : LongInt) : Boolean;
                
  end;

  PTimer64 = ^TTimer64;
  TTimer64 = class
      running : Boolean;

      function  Time : Single;
      procedure Start;
      procedure Stop;
      procedure Reset;
      procedure SetFormat(format : byte);

      // Setup
      constructor Create(format : byte);
      destructor Destroy; override;

    private
      scale_factor : int64;
      itime,
      ftime : int64;
  end;

  TMouseStruct = record
    // Mouse Position
    X, Y  : LongInt;
    // Buttons
    Left,
    Right : Boolean;
  end;

// Pack/UnPack colors
function  RGB(R, G, B : Byte) : LongWord;
procedure UnRGB(color : LongWord; var R, G, B : Byte);

// Global Vars
var
  ScreenBpp : Byte;
  debug : string;

  //========================================================
  // Input Device Control for TSelfHyper64 and TSelfFullHyper64 ONLY!!!!!
    Keys  : array [0..255] of Boolean; // Keyboard Control
    Mouse : TMouseStruct;              // Mouse Control
  //========================================================

// Complete List of Virtual Key Codes
const
  VK_LBUTTON   = $01; // Left mouse button
  VK_RBUTTON   = $02; // Right mouse button
  VK_CANCEL    = $03; // Control-break processing
  VK_MBUTTON   = $04; // Middle mouse button (three-button mouse)
  VK_BACK	     = $08; // BACKSPACE key
  VK_TAB	     = $09; // TAB key
  VK_CLEAR	   = $0C; // CLEAR key
  VK_RETURN	   = $0D; // ENTER key
  VK_SHIFT	   = $10; // SHIFT key
  VK_CONTROL   = $11; // CTRL key
  VK_MENU	     = $12; // ALT key
  VK_PAUSE	   = $13; // PAUSE key
  VK_CAPITAL   = $14; // CAPS LOCK key
  VK_ESCAPE	   = $1B; // ESC key
  VK_SPACE	   = $20; // SPACEBAR
  VK_PRIOR	   = $21; // PAGE UP key
  VK_NEXT	     = $22; // PAGE DOWN key
  VK_END	     = $23; // END key
  VK_HOME	     = $24; // HOME key
  VK_LEFT	     = $25; // LEFT ARROW key
  VK_UP	       = $26; // UP ARROW key
  VK_RIGHT	   = $27; // RIGHT ARROW key
  VK_DOWN	     = $28; // DOWN ARROW key
  VK_SELECT	   = $29; // SELECT key
  VK_EXECUTE   = $2B; // EXECUTE key
  VK_SNAPSHOT  = $2C; // PRINT SCREEN key for Windows 3.0 and later
  VK_INSERT	   = $2D; // INS key
  VK_DELETE	   = $2E; // DEL key
  VK_HELP	     = $2F; // HELP key
  VK_0	       = $30; // 0 key
  VK_1	       = $31; // 1 key
  VK_2	       = $32; // 2 key
  VK_3	       = $33; // 3 key
  VK_4	       = $34; // 4 key
  VK_5	       = $35; // 5 key
  VK_6	       = $36; // 6 key
  VK_7	       = $37; // 7 key
  VK_8	       = $38; // 8 key
  VK_9	       = $39; // 9 key
  VK_A	       = $41; // A key
  VK_B	       = $42; // B key
  VK_C	       = $43; // C key
  VK_D	       = $44; // D key
  VK_E	       = $45; // E key
  VK_F	       = $46; // F key
  VK_G	       = $47; // G key
  VK_H	       = $48; // H key
  VK_I	       = $49; // I key
  VK_J	       = $4A; // J key
  VK_K	       = $4B; // K key
  VK_L	       = $4C; // L key
  VK_M	       = $4D; // M key
  VK_N	       = $4E; // N key
  VK_O	       = $4F; // O key
  VK_P	       = $50; // P key
  VK_Q	       = $51; // Q key
  VK_R	       = $52; // R key
  VK_S	       = $53; // S key
  VK_T	       = $54; // T key
  VK_U	       = $55; // U key
  VK_V	       = $56; // V key
  VK_W	       = $57; // W key
  VK_X	       = $58; // X key
  VK_Y	       = $59; // Y key
  VK_Z	       = $5A; // Z key
  VK_LWIN	     = $5B; // Left Windows key (Microsoft Natural Keyboard)
  VK_RWIN	     = $5C; // Right Windows key (Microsoft Natural Keyboard)
  VK_APPS	     = $5D; // Applications key (Microsoft Natural Keyboard)
  VK_NUMPAD0	 = $60; // Numeric keypad 0 key
  VK_NUMPAD1	 = $61; // Numeric keypad 1 key
  VK_NUMPAD2	 = $62; // Numeric keypad 2 key
  VK_NUMPAD3	 = $63; // Numeric keypad 3 key
  VK_NUMPAD4	 = $64; // Numeric keypad 4 key
  VK_NUMPAD5	 = $65; // Numeric keypad 5 key
  VK_NUMPAD6	 = $66; // Numeric keypad 6 key
  VK_NUMPAD7	 = $67; // Numeric keypad 7 key
  VK_NUMPAD8	 = $68; // Numeric keypad 8 key
  VK_NUMPAD9	 = $69; // Numeric keypad 9 key
  VK_MULTIPLY	 = $6A; // Multiply key
  VK_ADD	     = $6B; // Add key
  VK_SEPARATOR = $6C; // Separator key
  VK_SUBTRACT	 = $6D; // Subtract key
  VK_DECIMAL	 = $6E; // Decimal key
  VK_DIVIDE	   = $6F; // Divide key
  VK_F1	       = $70; // F1 key
  VK_F2	       = $71; // F2 key
  VK_F3	       = $72; // F3 key
  VK_F4	       = $73; // F4 key
  VK_F5	       = $74; // F5 key
  VK_F6	       = $75; // F6 key
  VK_F7	       = $76; // F7 key
  VK_F8	       = $77; // F8 key
  VK_F9	       = $78; // F9 key
  VK_F10	     = $79; // F10 key
  VK_F11	     = $7A; // F11 key
  VK_F12	     = $7B; // F12 key
  VK_F13	     = $7C; // F13 key
  VK_F14	     = $7D; // F14 key
  VK_F15	     = $7E; // F15 key
  VK_F16       = $7F; // F16 key
  VK_F17	     = $80; // F17 key
  VK_F18	     = $81; // F18 key
  VK_F19	     = $82; // F19 key
  VK_F20	     = $83; // F20 key
  VK_F21	     = $84; // F21 key
  VK_F22	     = $85; // F22 key
  VK_F23	     = $86; // F23 key
  VK_F24	     = $87; // F24 key
  VK_NUMLOCK   = $90; // NUM LOCK key
  VK_SCROLL    = $91; // SCROLL LOCK key
  VK_ATTN      = $F6; // Attn key
  VK_CRSEL	   = $F7; // CrSel key
  VK_EXSEL	   = $F8; // ExSel key
  VK_EREOF	   = $F9; // Erase EOF key
  VK_PLAY	     = $FA; // Play key
  VK_ZOOM	     = $FB; // Zoom key
  VK_NONAME	   = $FC; // Reserved for future use.
  VK_PA1	     = $FD; // PA1 key
  VK_OEM_CLEAR = $FE; // Clear key

// Internal
type
  TAlphaTable = array [-255..255] of longint;
  PAlphaTable = ^TAlphaTable;

procedure alpha_line16(src,dst : pline16; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable);
procedure alpha_line24(src,dst : pline24; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable);
procedure alpha_line32(src,dst : pline8; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable);

procedure alphamap_line16(src,dst : pline16; size, s_xi, d_xi : longint; Alpha : PLine8);
procedure alphamap_line24(src,dst : pline24; size, s_xi, d_xi : longint; Alpha : PLine8);
procedure alphamap_line32(src,dst : pline8; size, s_xi, d_xi : longint; Alpha : PLine8);

procedure alphakey_line16(src,dst : pline16; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable; key : longword);
procedure alphakey_line24(src,dst : pline24; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable; key : longword);
procedure alphakey_line32(src,dst : pline8; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable; key : longword);

procedure add_line16(src,dst : pline16; size, s_xi, d_xi : longint);
procedure add_line24(src,dst : pline24; size, s_xi, d_xi : longint);
procedure add_line32(src,dst : pline8; size, s_xi, d_xi : longint);

procedure sub_line16(src,dst : pline16; size, s_xi, d_xi : longint);
procedure sub_line24(src,dst : pline24; size, s_xi, d_xi : longint);
procedure sub_line32(src,dst : pline8; size, s_xi, d_xi : longint);

procedure xor_line16(src,dst : pline16; size, s_xi, d_xi : longint);
procedure xor_line24(src,dst : pline24; size, s_xi, d_xi : longint);
procedure xor_line32(src,dst : pline8; size, s_xi, d_xi : longint);

procedure extractred_line16(src,dst : pline16; size, s_xi, d_xi : longint);
procedure extractred_line24(src,dst : pline24; size, s_xi, d_xi : longint);
procedure extractred_line32(src,dst : pline8; size, s_xi, d_xi : longint);

procedure extractgreen_line16(src,dst : pline16; size, s_xi, d_xi : longint);
procedure extractgreen_line24(src,dst : pline24; size, s_xi, d_xi : longint);
procedure extractgreen_line32(src,dst : pline8; size, s_xi, d_xi : longint);

procedure extractblue_line16(src,dst : pline16; size, s_xi, d_xi : longint);
procedure extractblue_line24(src,dst : pline24; size, s_xi, d_xi : longint);
procedure extractblue_line32(src,dst : pline8; size, s_xi, d_xi : longint);

procedure extractalpha_line16(src : PLine8; dst : pline16; size, s_xi, d_xi : longint);
procedure extractalpha_line24(src : PLine8; dst : pline24; size, s_xi, d_xi : longint);
procedure extractalpha_line32(src : PLine8; dst : pline8; size, s_xi, d_xi : longint);

procedure Blur2x_16(Buffer : TBuffer64);
procedure Blur2x_24(Buffer : TBuffer64);
procedure Blur2x_32(Buffer : TBuffer64);

procedure Negative_16(Buffer : TBuffer64);
procedure Negative_24(Buffer : TBuffer64);
procedure Negative_32(Buffer : TBuffer64);

procedure Greyscale_16(Buffer : TBuffer64);
procedure Greyscale_24(Buffer : TBuffer64);
procedure Greyscale_32(Buffer : TBuffer64);

implementation

uses Messages, SysUtils, Classes, Graphics, GraphicEx, Math;

//========================================================
// Get Screen Bits per Pixel
function THyper64.GlobalBpp : Integer;
var DC : HDC;
begin
  if not Assigned(Self) then exit;
  DDPrimary.GetDC(DC);
  GlobalBpp:= GetDeviceCaps(DC, BITSPIXEL);
  DDPrimary.ReleaseDC(DC);
end;

//========================================================
// Rectangle Intersect Check
function RectIntersect(ax1, ay1, ax2, ay2, bx1, by1, bx2, by2 : LongInt) : Boolean;
var x1, y1, x2, y2, tmp : LongInt;
begin
  if ax1> ax2 then begin
    tmp:= ax1;
    ax1:= ax2;
    ax2:= tmp;
  end;
  if ay1> ay2 then begin
    tmp:= ay1;
    ay1:= ay2;
    ay2:= tmp;
  end;
  if bx1> bx2 then begin
    tmp:= bx1;
    bx1:= bx2;
    bx2:= tmp;
  end;
  if by1> by2 then begin
    tmp:= by1;
    by1:= by2;
    by2:= tmp;
  end;
  x1:= Max(ax1, bx1);
	y1:= Max(ay1, by1);
	x2:= Min(ax2, bx2);
	y2:= Min(ay2, by2);
  RectIntersect:= (x1<= x2) and (y1<= y2);
end;

//========================================================
//======================== TTimer ========================
//========================================================
// Get Programmable Interval Timer Value
function GetPITValue(var val : int64) : Boolean; stdcall;
external 'kernel32.dll' name 'QueryPerformanceCounter';

constructor TTimer64.Create(format : byte);
begin
  inherited Create;
  case format of
    tfSec      : scale_factor:= 1000000;
    tfMiliSec  : scale_factor:= 1000;
    tfMicroSec : scale_factor:= 1;
  else
    scale_factor:= 1000000;
  end;
end;

destructor TTimer64.Destroy;
begin
  inherited Destroy;
end;

//========================================================
// Get Time
function TTimer64.Time : Single;
begin
  if not Assigned(Self) then exit;
  if running then begin
    GetPITValue(ftime);
    Time:= (ftime- itime)/ scale_factor;
  end
  else Time:= (ftime- itime)/ scale_factor;
end;

//========================================================
// Set timer interval
procedure TTimer64.SetFormat(format : byte);
begin
  if not Assigned(Self) then exit;
  case format of
    tfSec      : scale_factor:= 1000000;
    tfMiliSec  : scale_factor:= 1000;
    tfMicroSec : scale_factor:= 1;
  else
    scale_factor:= 1000000;
  end;
end;

//========================================================
// Start time Counting
procedure TTimer64.Start;
begin
  if not Assigned(Self) then exit;
  running:= true;
  GetPITValue(itime);
end;

//========================================================
// Finish time Counting
procedure TTimer64.Stop;
begin
  if not Assigned(Self) then exit;
  GetPITValue(ftime);
  running:= false;
end;

//========================================================
// Set timer back to zero
procedure TTimer64.Reset;
begin
  if not Assigned(Self) then exit;
  GetPITValue(itime);
end;

//========================================================
//======================= THyper64 =======================
//========================================================
// Class Constructor
constructor THyper64.Create(h_Wnd : HWnd; SizeX, SizeY : LongInt);
var Rect : TRect;
begin
  inherited Create;

  if self<> nil then FreeAll;
  Handle:= h_Wnd;
  SetRect(Rect, 0, 0, SizeX, SizeY);
  AdjustWindowRectEx(Rect, GetWindowLong(Handle, GWL_STYLE), True, GetWindowLong(Handle, GWL_EXSTYLE));
  Windows.SetWindowPos(Handle, 0, 0, 0, Rect.Right- Rect.Left, Rect.Bottom- Rect.Top,
                       SWP_NOZORDER or SWP_NOMOVE or SWP_NOACTIVATE);
  XSize:= SizeX;
  YSize:= SizeY;
  XMax:= SizeX- 1;
  YMax:= SizeY- 1;
  XMid:= SizeX shr 1;
  YMid:= SizeY shr 1;

  IsFull:= false;
  InitAll(false);
  if not (ScreenBpp in [16, 24, 32]) then
    err_MSG('Create', 'Desktop color depth not supported (only 16,24,32bit)');
  Bitpp:= ScreenBpp;;

  Fill(0);
  FillBack(0);
end;

//========================================================
// Release THyper64
destructor THyper64.Destroy;
begin
  if not Assigned(Self) then exit;
  FreeAll;
  ShowCursor(true);
  inherited Destroy;
end;

//========================================================
// Class Destructor
procedure THyper64.FreeAll;
begin
  ReleaseAll;
end;

//========================================================
// Report Error and exit
procedure THyper64.err_MSG(Source, ErrMsg : String);
begin
  if Assigned(Self) then Destroy;
  MessageBox(0, PChar('[THyper64]'+ Source+ ' -> '+ ErrMsg), 'Runtime Error', MB_OK);
  Halt;
end;

//========================================================
// Setup DirectX
procedure THyper64.InitAll(FullScreen : Boolean);
var
  hRet : HResult;
  {$IFDEF DX3}
  ddsd : TDDSurfaceDesc;
  ddsCaps : TDDSCaps;
  {$ELSE}
  ddsd : TDDSurfaceDesc2;
  ddsCaps : TDDSCaps2;
  {$ENDIF}
  {$IFDEF DX6}
  DDTmpObj : IDirectDraw;
  {$ENDIF}
  CoopLevel : Cardinal;
begin
  // DirectDraw setup

  {$IFDEF DX3}
  hRet:= DirectDrawCreate(nil, DDObject, nil);
  if hRet<> DD_OK then
    err_MSG('DirectDrawCreate', DDErrorString(hRet));
  {$ENDIF}

  {$IFDEF DX6}
  hRet:= DirectDrawCreate(nil, DDTmpObj, nil);
  if hRet<> DD_OK then
    err_MSG('DirectDrawCreate', DDErrorString(hRet));

  hRet:= DDTmpObj.QueryInterface(IID_IDirectDraw4, DDObject);
  if hRet<> DD_OK then
    err_MSG('QueryInterface', DDErrorString(hRet));
  {$ENDIF}

  {$IFDEF DX7}
  hRet:= DirectDrawCreateEx(nil, DDObject, IDirectDraw7, nil);
  if hRet<> DD_OK then
    err_MSG('DirectDrawCreateEx', DDErrorString(hRet));
  {$ENDIF}

  if FullScreen then begin
    hRet:= DDObject.SetCooperativeLevel(Handle, DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN or DDSCL_ALLOWREBOOT);
    if hRet<> DD_OK then
      err_MSG('SetCooperativeLevel', DDErrorString(hRet));

    {$IFDEF DX3}
    hRet:= DDObject.SetDisplayMode(XSize, YSize, Bitpp);
    if hRet<> DD_OK then
      err_MSG('SetDisplayMode', DDErrorString(hRet));
    {$ELSE}
    hRet:= DDObject.SetDisplayMode(XSize, YSize, Bitpp, 0, 0);
    if hRet<> DD_OK then
      err_MSG('SetDisplayMode', DDErrorString(hRet));
    {$ENDIF}

    ZeroMemory(@ddsd, SizeOf(ddsd));
    ddsd.dwSize           := SizeOf(ddsd);
    ddsd.dwFlags          := DDSD_CAPS or DDSD_BACKBUFFERCOUNT;
    ddsd.dwBackBufferCount:= 1;
    ddsd.ddsCaps.dwCaps   := DDSCAPS_PRIMARYSURFACE or DDSCAPS_FLIP or DDSCAPS_COMPLEX;
    hRet:= DDObject.CreateSurface(ddsd, DDPrimary, nil);
    if hRet<> DD_OK then
      err_MSG('CreateSurface', DDErrorString(hRet));

    ZeroMemory(@ddsCaps, SizeOf(ddsCaps));
    ddsCaps.dwCaps:= DDSCAPS_BACKBUFFER;
    hRet:= DDPrimary.GetAttachedSurface(ddsCaps, DDBackSurface);
    if hRet<> DD_OK then
      err_MSG('GetAttachedSurface', DDErrorString(hRet));
  end
  else begin
    hRet:= DDObject.SetCooperativeLevel(Handle, DDSCL_NORMAL);
    if hRet<> DD_OK then
      err_MSG('SetCooperativeLevel', DDErrorString(hRet));

    ZeroMemory(@ddsd, SizeOf(ddsd));
    ddsd.dwSize        := SizeOf(ddsd);
    ddsd.dwFlags       := DDSD_CAPS;
    ddsd.ddsCaps.dwCaps:= DDSCAPS_PRIMARYSURFACE;
    hRet:= DDObject.CreateSurface(ddsd, DDPrimary, nil);
    if hRet<> DD_OK then
      err_MSG('CreateSurface', DDErrorString(hRet));

    ZeroMemory(@ddsd, SizeOf(ddsd));
    ddsd.dwSize        := SizeOf(ddsd);
    ddsd.dwWidth       := XSize;
    ddsd.dwHeight      := YSize;
    ddsd.dwFlags       := DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT;
    ddsd.ddsCaps.dwCaps:= DDSCAPS_OFFSCREENPLAIN or DDSCAPS_SYSTEMMEMORY;
	  hRet:= DDObject.CreateSurface(ddsd, DDBackSurface, nil);
   	if hRet<> 0 then
      err_MSG('CreateSurface', DDErrorString(hRet));

  end;

  hRet:= DDObject.CreateClipper(0, DDClipper, nil);
  if hRet<> DD_OK then
    err_MSG('CreateClipper', DDErrorString(hRet));

  hRet:= DDClipper.SetHWnd(0, Handle);
  if hRet<> DD_OK then
    err_MSG('SetHWnd', DDErrorString(hRet));

  hRet:= DDPrimary.SetClipper(DDClipper);
  if hRet<> DD_OK then
    err_MSG('SetClipper', DDErrorString(hRet));

  ScreenBpp:= GlobalBpp;
end;

//========================================================
// Release DirectX
procedure THyper64.ReleaseAll;
begin
  if Assigned(DDBackSurface) then
    DDBackSurface:= nil;
  if Assigned(DDPrimary) then
    DDPrimary:= nil;
  if Assigned(DDClipper) then
    DDClipper:= nil;
  if Assigned(DDObject) then begin
    DDObject.RestoreDisplayMode;
    DDObject.SetCooperativeLevel(Handle, DDSCL_NORMAL);
    DDObject:= nil;
  end;
end;

//========================================================
// Restore All
procedure THyper64.RestoreAll;
var hRet : HResult;
begin
  if not Assigned(Self) then exit;
  DDPrimary._Restore;
  if not IsFull then
    DDBackSurface._Restore;
end;

// Sets the window position in the desktop
procedure THyper64.SetWindowPos(XPos, YPos : LongInt);
begin
  if not Assigned(Self) then exit;
  if not IsFull then
    Windows.SetWindowPos(Handle, HWND_TOP, XPos, YPos, XSize, YSize, SWP_SHOWWINDOW);
end;

//========================================================
// Fill BackBuffer with color
procedure THyper64.FillBack(color : LongWord);
var
	bltfx : TDDBLTFX;
  hRet : HResult;
begin
  if not Assigned(Self) then exit;
  ZeroMemory(@bltfx, SizeOf(bltfx));
	bltfx.dwSize     := SizeOf(bltfx);
	bltfx.dwDDFX     := 0;
	bltfx.dwFillColor:= color;

  while (true) do begin
    hRet:= DDBackSurface.Blt(nil, nil, nil, DDBLT_COLORFILL, @bltfx);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Fill FrontBuffer with color
procedure THyper64.Fill(color : LongWord);
var
	bltfx : TDDBLTFX;
  hRet : HResult;
  dstRect : TRect;
  Pt : TPoint;
begin
  if not Assigned(Self) then exit;
  ZeroMemory(@bltfx, SizeOf(bltfx));
	bltfx.dwSize     := SizeOf(bltfx);
	bltfx.dwDDFX     := 0;
	bltfx.dwFillColor:= color;

  Windows.GetClientRect(Handle, dstRect);
  Pt.x:= 0;
  Pt.y:= 0;
  Windows.ClientToScreen(Handle, Pt);
  OffsetRect(dstRect, Pt.x, Pt.y);

  while (true) do begin
    hRet:= DDPrimary.Blt(@dstRect, nil, nil, DDBLT_COLORFILL, @bltfx);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
//====================== TFullHyper ======================
//========================================================
// Report Error and exit
procedure TFullHyper64.err_MSG(Source, ErrMsg : String);
begin
  if Assigned(Self) then Destroy;
  MessageBox(0, PChar('[TFullHyper64]'+ Source+ ' -> '+ ErrMsg), 'Runtime Error', MB_OK);
  Halt;
end;

//========================================================
// Class Constructor
constructor TFullHyper64.Create(h_Wnd : HWnd; SizeX, SizeY, Bpp : LongInt);
var Rect : TRect;
begin
  if self<> nil then FreeAll;
  Handle:= h_Wnd;
  XSize:= SizeX;
  YSize:= SizeY;
  XMax:= SizeX- 1;
  YMax:= SizeY- 1;
  XMid:= SizeX shr 1;
  YMid:= SizeY shr 1;
  SetWindowLong(Handle, GWL_STYLE, WS_POPUP);

  if not (Bpp in [16, 24, 32]) then
    err_MSG('Create', 'Desktop color depth not supported (only 16,24,32bit)');
  Bitpp:= Bpp;

  IsFull:= true;
  InitAll(true);
  ShowCursor(false);

  Fill(0);
  FillBack(0);
end;

//========================================================
// Class Destructor
destructor TFullHyper64.Destroy;
var hRet : HResult;
begin
  ReleaseAll;
  ChangeDisplaySettings(TDEVMODE(nil^), 0);

  ShowCursor(true);
  IsFull:= false;
  inherited Destroy;
end;

//========================================================
//====================== TSelfHyper ======================
//========================================================
// Report Error and exit
procedure TSelfHyper64.err_MSG(Source, ErrMsg : String);
begin
  if Assigned(Self) then Destroy;
  MessageBox(0, PChar('[TSelfHyper64]'+ Source+ ' -> '+ ErrMsg), 'Runtime Error', MB_OK);
  Halt;
end;

//========================================================
// Window Procedure
function s_WindowProc(h_Wnd : HWND; aMSG, wParam, lParam : Cardinal) : Cardinal; stdcall;
begin
  result:= 0;
  if aMSG= WM_SYSCOMMAND then begin
    case wParam of
      SC_SCREENSAVE,
      SC_MONITORPOWER : begin
        result:= 0;
        exit;
      end;
    end;
  end;
  case aMsg of
    WM_CLOSE,
    WM_DESTROY : begin
      PostMessage(h_Wnd, WM_QUIT, 0, 0);
      Result:= 0;
      exit;
    end;
    WM_KEYDOWN : begin
      Keys[wParam]:= true;
      result:= 0;
      exit;
    end;
    WM_KEYUP : begin
		  Keys[wParam]:= false;
      result:= 0;
		  exit;
    end;
    WM_MOUSEMOVE : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      result:= 0;
      exit;
    end;
    WM_LBUTTONDOWN : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      Mouse.Left:= true;
      result:= 0;
      exit;
    end;
    WM_LBUTTONUP : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      Mouse.Left:= false;
      result:= 0;
      exit;
    end;
    WM_RBUTTONDOWN : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      Mouse.Right:= true;
      result:= 0;
      exit;
    end;
    WM_RBUTTONUP : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      Mouse.Right:= false;
      result:= 0;
      exit;
    end;
  else
    result:= DefWindowProc(h_Wnd, aMsg, WParam, LParam);
  end;
end;

//========================================================
// Process messages
function THyper64.DoEvents : Boolean;
var aMSG : TMsg;
begin
  if not Assigned(self) then begin
    result:= false;
    exit;
  end;
  if PeekMessage(aMSG, Handle, 0, 0, PM_REMOVE) then begin
    if (aMSG.Message= WM_QUIT) then begin
      result:= false;
      exit;
    end
    else begin
      TranslateMessage(aMSG);
  	  DispatchMessage(aMSG);
    end;
  end;
  result:= true;
end;

//========================================================
// Class Constructor
constructor TSelfHyper64.Create(SizeX, SizeY : LongInt; UserTitle : PChar);
var
  Rect : TRect;
  wc   : TWNDCLASS;
  hRet : HResult;
  i    : byte;
  xpos, ypos : longint;
  h_Instance : HInst;
  WindowRect : TRECT;
  style, styleex : Cardinal;
begin
  if self<> nil then FreeAll;
  for i:= 0 to 255 do Keys[i]:= false;
  Title:= UserTitle;

  h_Instance:= GetModuleHandle(nil);

  WindowRect.left:= 0;
  WindowRect.right:= SizeX;
  WindowRect.top:= 0;
  WindowRect.bottom:= SizeY;

  if not GetClassInfo(h_Instance, 'TSelfHyper64', wc) then begin
    with wc do begin
   	  style			   := CS_HREDRAW or CS_VREDRAW or CS_OWNDC;
	    lpfnWndProc	 := @s_WindowProc;
	    cbClsExtra	 := 0;
	    cbWndExtra	 := 0;
	    hInstance		 := h_Instance;
	    hIcon			   := LoadIcon(0, IDI_WINLOGO);
  	  hCursor			 := LoadCursor(0, IDC_ARROW);
      hbrBackground:= GetStockObject(BLACK_BRUSH);
		  lpszMenuName := nil;
		  lpszClassName:= 'TSelfHyper64';
	  end;
    hRet:= Windows.RegisterClass(wc);
    if hRet= 0 then
	    err_MSG('RegisterClass', 'Error registering window class...');
  end;

  style:= WS_OVERLAPPEDWINDOW or WS_CLIPSIBLINGS or WS_CLIPCHILDREN;
  styleex:= WS_EX_APPWINDOW or WS_EX_WINDOWEDGE;
  AdjustWindowRectEx(WindowRect, style, false, styleex);
  xpos:= (GetSystemMetrics(SM_CXSCREEN)- SizeX) shr 1;
  ypos:= (GetSystemMetrics(SM_CYSCREEN)- SizeY) shr 1;

  hRet:= CreateWindowEx(styleex, 'TSelfHyper64', Title, style, xpos, ypos,
                        WindowRect.Right- WindowRect.Left,
                        WindowRect.Bottom- WindowRect.Top,
                        0, 0, h_Instance, nil);

	if hRet= 0 then
    err_MSG('CreateWindowEx', 'Error creating window...')
	else
    Handle:= hRet;

	ShowWindow(Handle, SW_SHOW);
	UpdateWindow(Handle);
  SetFocus(Handle);

  XSize:= SizeX;
  YSize:= SizeY;
  XMax:= SizeX- 1;
  YMax:= SizeY- 1;
  XMid:= SizeX shr 1;
  YMid:= SizeY shr 1;

  IsFull:= false;
  InitAll(false);
  if not (ScreenBpp in [16, 24, 32]) then
    err_MSG('Create', 'Desktop color depth not supported (only 16,24,32bit)');
  Bitpp:= ScreenBpp;

  Fill(0);
  FillBack(0);
end;

//========================================================
// Class Destructor
destructor TSelfHyper64.Destroy;
begin
  IsFull:= false;
  DestroyWindow(Handle);
  Windows.UnregisterClass('TSelfHyper64', h_Instance);
  inherited Destroy;
end;

//========================================================
//==================== TSelfFullHyper ====================
//========================================================
// Report Error and exit
procedure TSelfFullHyper64.err_MSG(Source, ErrMsg : String);
begin
  if Assigned(Self) then Destroy;
  MessageBox(0, PChar('[TSelfFullHyper64]'+ Source+ ' -> '+ ErrMsg), 'Runtime Error', MB_OK);
  Halt;
end;

//========================================================
// Window Procedure
function sf_WindowProc(h_Wnd : HWND; aMSG, wParam, lParam : longint) : longint; stdcall; export;
begin
  result:= 0;
  if aMSG= WM_SYSCOMMAND then begin
    case wParam of
      SC_SCREENSAVE,
      SC_MONITORPOWER : begin
        result:= 0;
        exit;
      end;
    end;
  end;
  case aMsg of
    WM_CLOSE,
    WM_DESTROY : begin
      PostQuitMessage(0);
      Result:= 0;
      exit;
    end;
    WM_KEYDOWN : begin
      Keys[wParam]:= true;
      result:= 0;
      exit;
    end;
    WM_KEYUP : begin
		  Keys[wParam]:= false;
      result:= 0;
		  exit;
    end;
    WM_MOUSEMOVE : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      result:= 0;
      exit;
    end;
    WM_LBUTTONDOWN : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      Mouse.Left:= true;
      result:= 0;
      exit;
    end;
    WM_LBUTTONUP : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      Mouse.Left:= false;
      result:= 0;
      exit;
    end;
    WM_RBUTTONDOWN : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      Mouse.Right:= true;
      result:= 0;
      exit;
    end;
    WM_RBUTTONUP : with Mouse do begin
      X:= LoWord(lParam);
      Y:= HiWord(lParam);
      Mouse.Right:= false;
      result:= 0;
      exit;
    end;
  else
    result:= DefWindowProc(h_Wnd, aMsg, WParam, LParam);
  end;
end;

//========================================================
// Class Constructor
constructor TSelfFullHyper64.Create(SizeX, SizeY, Bpp : LongInt; UserTitle : PChar);
var
  Rect : TRect;
  wc   : TWNDCLASS;
  hRet : HResult;
  i    : byte;
  WindowRect : TRECT;
  style, styleex : Cardinal;
begin
  if self<> nil then FreeAll;
  for i:= 0 to 255 do Keys[i]:= false;
  Title:= UserTitle;
  h_Instance:= GetModuleHandle(nil);

  WindowRect.left:= 0;
  WindowRect.right:= SizeX;
  WindowRect.top:= 0;
  WindowRect.bottom:= SizeY;

  with wc do begin
	  style			   := CS_HREDRAW or CS_VREDRAW or CS_OWNDC;
	  lpfnWndProc	 := @sf_WindowProc;
	  cbClsExtra	 := 0;
	  cbWndExtra	 := 0;
	  hInstance		 := h_Instance;
	  hIcon			   := LoadIcon(0, IDI_WINLOGO);
  	hCursor			 := LoadCursor(0, IDC_ARROW);
		hbrBackground:= GetStockObject(BLACK_BRUSH);
		lpszMenuName := nil;
		lpszClassName:= 'TSelfFullHyper64';
	end;
	hRet:= Windows.RegisterClass(wc);
  if hRet= 0 then
	  err_MSG('RegisterClass', 'Error registering window class...');

  style:= WS_POPUP or WS_CLIPSIBLINGS or WS_CLIPCHILDREN;
  styleex:= WS_EX_APPWINDOW;
  AdjustWindowRectEx(WindowRect, style, false, styleex);

	hRet:= CreateWindowEx(styleex, 'TSelfFullHyper64', Title, style, 0, 0,
                        GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
                        0, 0, h_Instance, nil);
	if hRet= 0 then
	  err_MSG('CreateWindowEx', 'Error creating window...')
	else
	  Handle:= hRet;

	ShowWindow(Handle, SW_SHOW);
	UpdateWindow(Handle);
  SetFocus(Handle);

  XSize:= SizeX;
  YSize:= SizeY;
  XMax:= SizeX- 1;
  YMax:= SizeY- 1;
  XMid:= SizeX shr 1;
  YMid:= SizeY shr 1;

  if not (Bpp in [16, 24, 32]) then
    err_MSG('Create', 'Desktop color depth not supported (only 16,24,32bit)');
  Bitpp:= Bpp;

  IsFull:= true;
  InitAll(true);
  ShowCursor(false);

  Fill(0);
  FillBack(0);
end;

//========================================================
// Class Destructor
destructor TSelfFullHyper64.Destroy;
var hRet : HResult;
begin
  ReleaseAll;
  ChangeDisplaySettings(TDEVMODE(nil^), 0);

  ShowCursor(true);
  IsFull:= false;
  DestroyWindow(Handle);
  Windows.UnregisterClass('TSelfFullHyper64', h_Instance);
  inherited Destroy;
end;

//========================================================
//======================= TBuffer ========================
//========================================================
// Report Error and exit
procedure TBuffer64.err_MSG(Source, ErrMsg : String);
begin
  if Assigned(Self) then Destroy;
  ChangeDisplaySettings(TDEVMODE(nil^), 0);
  MessageBox(0, PChar('[TBuffer]'+ Source+ ' -> '+ ErrMsg), 'Runtime Error', MB_OK);
  Halt;
end;

//========================================================
// Class Constructor
constructor TBuffer64.Create(Hyper : THyper64; SizeX, SizeY : LongInt; VideoMem : Boolean);
var
  hRet : HResult;
  {$IFDEF DX3}
  ddsd : TDDSurfaceDesc;
  {$ELSE}
  ddsd : TDDSurfaceDesc2;
  {$ENDIF}
begin
  inherited Create;
  if self<> nil then FreeAll;

  Handle:= Hyper.Handle;
  DDObject:= Hyper.DDObject;
  DDPrimary:= Hyper.DDPrimary;
  DDBackSurface:= Hyper.DDBackSurface;
  hXSize:= Hyper.XSize;
  hYSize:= Hyper.YSize;
  hBpp:= Hyper.Bitpp;
  IsFull:= Hyper.IsFull;

  ZeroMemory(@ddsd, SizeOf(ddsd));
  ddsd.dwSize  := SizeOf(ddsd);
  ddsd.dwWidth := SizeX;
  ddsd.dwHeight:= SizeY;
  ddsd.dwFlags := DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT;
  if VideoMem then
    ddsd.ddsCaps.dwCaps:= DDSCAPS_OFFSCREENPLAIN or DDSCAPS_VIDEOMEMORY
  else
    ddsd.ddsCaps.dwCaps:= DDSCAPS_OFFSCREENPLAIN or DDSCAPS_SYSTEMMEMORY;
	hRet:= DDObject.CreateSurface(ddsd, DDSurface, nil);
	if hRet<> 0 then begin
    ZeroMemory(@ddsd, SizeOf(ddsd));
    ddsd.dwSize        := SizeOf(ddsd);
    ddsd.dwWidth       := SizeX;
    ddsd.dwHeight      := SizeY;
    ddsd.dwFlags       := DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT;
    ddsd.ddsCaps.dwCaps:= DDSCAPS_OFFSCREENPLAIN or DDSCAPS_SYSTEMMEMORY;
  	hRet:= DDObject.CreateSurface(ddsd, DDSurface, nil);
    if hRet<> 0 then
      err_MSG('CreateSurface', DDErrorString(hRet));
  end;

  Lock;
  UnLock;

  Fill(0);
  FreeMem(AlphaPtr);
  usesAlpha:= false;
end;

//========================================================
// Class Destructor
destructor TBuffer64.Destroy;
begin
  FreeAll;
  inherited Destroy;
end;

//========================================================
// Release DirectDraw
procedure TBuffer64.FreeAll;
begin
  if not Assigned(Self) then exit;
  if (Assigned(DDSurface)) then DDSurface:= nil;
end;

//========================================================
// Restore All
procedure TBuffer64.RestoreAll;
var hRet : HResult;
begin
  if not Assigned(Self) then exit;
  DDSurface._Restore;
  DDPrimary._Restore;
  if not IsFull then
    DDBackSurface._Restore;
end;

//========================================================
// Lock Surface
procedure TBuffer64.Lock;
var
  hRet : HResult;
  i, TmpPtr : LongInt;
begin
  if not Assigned(Self) then exit;
  ZeroMemory(@DDSurfaceDp, SizeOf(DDSurfaceDp));
  DDSurfaceDp.dwSize:= SizeOf(DDSurfaceDp);
  hRet:= DDSurface.Lock(nil, DDSurfaceDp, DDLOCK_NOSYSLOCK or DDLOCK_SURFACEMEMORYPTR, 0);
  if hRet<> DD_OK then
    err_MSG('Lock', DDErrorString(hRet));

  Ptr:= DDSurfaceDp.lpSurface;
  XSize:= DDSurfaceDp.dwWidth;
  YSize:= DDSurfaceDp.dwHeight;
  XMax:= XSize- 1;
  YMax:= YSize- 1;
  XMid:= XSize shr 1;
  YMid:= YSize shr 1;

  Bpsl:= DDSurfaceDp.lPitch;
  Bytepp:= Bpsl div XSize;
  Bitpp:= Bytepp shl 3;

  ReallocMem(Lines, YSize shl 2);
  TmpPtr:= LongInt(Ptr);
  for i:= 0 to YSize- 1 do begin
    Lines[i]:= System.Ptr(TmpPtr);
    Inc(TmpPtr, Bpsl);
  end;
  Pixels8:= Pointer(Lines);
  Pixels16:= Pointer(Lines);
  Pixels24:= Pointer(Lines);
  Pixels32:= Pointer(Lines);
end;

//========================================================
// UnLock Surface
procedure TBuffer64.UnLock;
var hRet : HResult;
begin
  if not Assigned(Self) then exit;
  hRet:= DDSurface.UnLock(nil);
  if hRet<> DD_OK then
    err_MSG('UnLock', DDErrorString(hRet));
end;

//========================================================
// Get Image Information
procedure TBuffer64.GetImageSize(filename : string; var sizex, sizey : LongInt);
var
  Picture : TPicture;
  Extensions : TStringList;
  Ext : String;
  i : longint;
begin
  if not FileExists(FileName) then
    err_MSG('GetImageInfo', 'File '+ FileName+ ' not found...');

  Picture:= TPicture.Create;
  Extensions:= TStringList.Create;
  try
    FileFormatList.GetExtensionList(Extensions);
    for i:= 0 to Extensions.Count- 1 do
      Extensions[i]:= '.'+ UpperCase(Extensions[i]);
    Extensions.Sort;
    Ext:= ExtractFileExt(FileName);
    if not Extensions.Find(Ext, i) then
      err_MSG('GetImageInfo', 'Extension '+ Ext+ ' not supported...');

    Picture.LoadFromFile(FileName);
    sizex:= Picture.Width;
    sizey:= Picture.Height;
  finally
    Extensions.Free;
    Picture.Free;
  end;
end;

//========================================================
// Load Image
procedure TBuffer64.LoadImage(filename : string; VideoMem : Boolean);
var
  Picture : TPicture;
  Btmap   : TBitmap;
  hRet    : HResult;
  bm    : Bitmap;
  Hbm   : HBitmap;
  bm_dc : HDC;
  dd_dc : HDC;
  {$IFDEF DX3}
  ddsd  : TDDSurfaceDesc;
  {$ELSE}
  ddsd  : TDDSurfaceDesc2;
  {$ENDIF}
  Extensions : TStringList;
  Ext : String;
  i : longint;
begin
  if not Assigned(Self) then exit;
  if not FileExists(FileName) then
    err_MSG('LoadImage', 'File '+ FileName+ ' not found...');

  Picture:= TPicture.Create;
  Btmap:= TBitmap.Create;
  Extensions:= TStringList.Create;
  try
    FileFormatList.GetExtensionList(Extensions);
    for i:= 0 to Extensions.Count- 1 do
      Extensions[i]:= '.'+ UpperCase(Extensions[i]);
    Extensions.Sort;
    Ext:= ExtractFileExt(FileName);
    if not Extensions.Find(Ext, i) then
      err_MSG('LoadImage', 'Extension '+ Ext+ ' not supported...');

    Picture.LoadFromFile(FileName);
    if not (Picture.Graphic is TBitmap) then begin
      with Btmap do begin
        PixelFormat:= pf24Bit;
        Width:= Picture.Width;
        Height:= Picture.Height;
        Canvas.Draw(0, 0, Picture.Graphic);
      end;
      Picture.Bitmap.Assign(Btmap);
    end;
    Hbm:= Picture.Bitmap.Handle;

    if (Picture.Width= 0) and (Picture.Height= 0) then
      err_MSG('LoadImage', 'Error loading '+ FileName+ '...');

    FreeAll;
    ZeroMemory(@ddsd, SizeOf(ddsd));
    ddsd.dwSize  := SizeOf(ddsd);
    ddsd.dwWidth := Picture.Width;
    ddsd.dwHeight:= Picture.Height;
    ddsd.dwFlags := DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT;
    if VideoMem then
      ddsd.ddsCaps.dwCaps:= DDSCAPS_OFFSCREENPLAIN or DDSCAPS_VIDEOMEMORY
    else
      ddsd.ddsCaps.dwCaps:= DDSCAPS_OFFSCREENPLAIN or DDSCAPS_SYSTEMMEMORY;
    hRet:= DDObject.CreateSurface(ddsd, DDSurface, nil);
    if hRet<> 0 then begin
      ZeroMemory(@ddsd, SizeOf(ddsd));
      ddsd.dwSize  := SizeOf(ddsd);
      ddsd.dwWidth := Picture.Width;
      ddsd.dwHeight:= Picture.Height;
      ddsd.dwFlags := DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT;
      ddsd.ddsCaps.dwCaps:= DDSCAPS_OFFSCREENPLAIN or DDSCAPS_SYSTEMMEMORY;
      if hRet<> 0 then
        err_MSG('CreateSurface', DDErrorString(hRet));
    end;
    Lock;
    UnLock;
    Fill(0);

    bm_dc:= CreateCompatibleDC(0);
    SelectObject(bm_dc, Hbm);
    GetObject(Hbm, SizeOf(bm), @bm);

    hRet:= DDSurface.GetDC(dd_dc);
    if hRet= DD_OK then begin
      BitBlt(dd_dc, 0, 0, XSize, YSize, bm_dc, 0, 0, SRCCOPY);
      DDSurface.ReleaseDC(dd_dc);
    end;
    DeleteDC(bm_dc);
  finally
    Extensions.Free;
    Picture.Free;
    Btmap.Free;
  end;
end;

//========================================================
// Load Alpha Channel from image
procedure TBuffer64.LoadAlpha(filename : string);
var
  Picture : TPicture;
  Btmap   : TBitmap;
  hRet    : HResult;
  {$IFDEF DX3}
  ddsd  : TDDSurfaceDesc;
  {$ELSE}
  ddsd  : TDDSurfaceDesc2;
  {$ENDIF}
  Extensions : TStringList;
  Ext : String;
  i, x, y : longint;
  a : byte;
  Row : PByte;
  TmpPtr : LongInt;
begin
  if not Assigned(Self) then exit;
  if not FileExists(FileName) then
    err_MSG('LoadImage', 'File '+ FileName+ ' not found...');

  Picture:= TPicture.Create;
  Extensions:= TStringList.Create;
  try
    FileFormatList.GetExtensionList(Extensions);
    for i:= 0 to Extensions.Count- 1 do
      Extensions[i]:= '.'+ UpperCase(Extensions[i]);
    Extensions.Sort;
    Ext:= ExtractFileExt(FileName);
    if not Extensions.Find(Ext, i) then
      err_MSG('LoadImage', 'Extension '+ Ext+ ' not supported...');

    Picture.LoadFromFile(FileName);
    if (Picture.Width= 0) and (Picture.Height= 0) then
      err_MSG('LoadImage', 'Error loading '+ FileName+ '...');
    if (Picture.Width<> XSize) and (Picture.Height<> YSize) then
      err_MSG('LoadImage', 'Error loading '+ FileName+ ', wrong dimensions...');
    if Picture.Bitmap.PixelFormat= pf8Bit then begin
      usesAlpha:= true;

      GetMem(AlphaPtr, XSize* YSize);
      ReallocMem(AlphaLines, YSize shl 2);
      TmpPtr:= LongInt(AlphaPtr);
      for i:= 0 to YSize- 1 do begin
        AlphaLines[i]:= System.Ptr(TmpPtr);
        Inc(TmpPtr, XSize);
      end;
      AlphaPixels:= Pointer(AlphaLines);

      for y:= 0 to YSize- 1 do begin
        Row:= Picture.Bitmap.Scanline[y];
        for x:= 0 to XSize- 1 do begin
          AlphaPixels[y][x]:= Byte(Row^);
          inc(Row);
        end;
      end;
    end
    else err_MSG('LoadImageAlpha', 'Invalid file '+ FileName+ ', must be 8bit for alpha...');

  finally
    Extensions.Free;
    Picture.Free;
  end;
end;

//========================================================
// Save Image
procedure TBuffer64.SaveTGA(filename : string);
var
  hRet   : HResult;
  bm     : Bitmap;
  Hbm    : HBitmap;
  bm_dc  : HDC;
  dd_dc  : HDC;
  Target : TTargaGraphic;
begin
  if not Assigned(Self) then exit;

  Target:= TTargaGraphic.Create;
  try
    Target.PixelFormat:= pf24Bit;
    Target.Width:= XSize;
    Target.Height:= YSize;
    Hbm:= Target.Handle;

    bm_dc:= CreateCompatibleDC(0);
    SelectObject(bm_dc, Hbm);
    GetObject(Hbm, SizeOf(bm), @bm);

    hRet:= DDSurface.GetDC(dd_dc);
    if hRet= DD_OK then begin
      BitBlt(bm_dc, 0, 0, XSize, YSize, dd_dc, 0, 0, SRCCOPY);
      DDSurface.ReleaseDC(dd_dc);
    end;
    DeleteDC(bm_dc);

    Target.SaveToFile(FileName);
  finally
    Target.Free;
  end;
end;

//========================================================
// Write String to TBuffer64
procedure TBuffer64.WriteStr(x, y : LongInt; Text : String; color : LongWord);
var
  h_DC : HDC;
  hRet : HResult;
  col  : TBGR;
begin
  if not Assigned(Self) then exit;
  hRet:= DDSurface.GetDC(h_DC);
  if hRet<> DD_OK then
    err_MSG('GetDC', DDErrorString(hRet));

  UnRGB(color, col.r, col.g, col.b);
  color:= Windows.RGB(col.r, col.g, col.b);

  SetTextColor(h_DC, color);
  SetBkMode(h_DC, TRANSPARENT);
  TextOut(h_DC, x, y, PChar(Text), Length(Text));

  hRet:= DDSurface.ReleaseDC(h_DC);
  if hRet<> DD_OK then
    err_MSG('ReleaseDC', DDErrorString(hRet));
end;

//========================================================
// Blit BackBuffer to FrontBuffer
procedure TBuffer64.FlipBackToPrimary;
var
  dstRect : TRect;
  hRet : HResult;
  Pt   : TPoint;
begin
  Windows.GetClientRect(Handle, dstRect);
  Pt.x:= 0;
  Pt.y:= 0;
  Windows.ClientToScreen(Handle, Pt);
  OffsetRect(dstRect, Pt.x, Pt.y);

  while (true) do begin
    hRet:= DDPrimary.Blt(@dstRect, DDBackSurface, nil, DDBLT_WAIT, nil);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Flip to THyper64
procedure TBuffer64.Flip(VSync : Boolean);
var
  dstRect : TRect;
  hRet : HResult;
  Pt   : TPoint;
  ddFlags : Cardinal;
  ddscaps : TDDSCAPS2;
begin
  if not Assigned(Self) then exit;
  if VSync then ddFlags:= DDFLIP_WAIT
  else ddFlags:= DDFLIP_NOVSYNC;

  Windows.GetClientRect(Handle, dstRect);
  Pt.x:= 0;
  Pt.y:= 0;
  Windows.ClientToScreen(Handle, Pt);
  OffsetRect(dstRect, Pt.x, Pt.y);

  if IsFull then begin
    hRet:= DDBackSurface.Blt(@dstRect, DDSurface, nil, DDBLT_WAIT, nil);
    if hRet= DDERR_SURFACELOST then RestoreAll;
    while (true) do begin
      hRet:= DDPrimary.Flip(nil, ddFlags or DDFLIP_WAIT);
      if hRet= DD_OK then exit;
      if hRet= DDERR_SURFACELOST then begin
        RestoreAll;
        exit;
      end;
      if hRet<> DDERR_WASSTILLDRAWING then exit;
    end;
  end
  else begin
    if VSync then DDObject.WaitForVerticalBlank(DDWAITVB_BLOCKEND, 0);
    while (true) do begin
      hRet:= DDPrimary.Blt(@dstRect, DDSurface, nil, DDBLT_WAIT, nil);
      if hRet= DD_OK then exit;
      if hRet= DDERR_SURFACELOST then begin
        RestoreAll;
        exit;
      end;
      if hRet<> DDERR_WASSTILLDRAWING then exit;
    end;
  end;
end;

//========================================================
// Blit to THyper64
procedure TBuffer64.Draw(x, y : LongInt);
var
  srcRect : TRect;
  hRet : HResult;
  x1, y1 : LongInt;
  x2, y2 : LongInt;
begin
  if not Assigned(Self) then exit;

  if (x> hXSize) or (y> hYSize) then exit;
  if (x+ XSize< 0) or (y+ YSize< 0) then exit;

  x1:= 0;
  y1:= 0;
  x2:= XSize;
  y2:= YSize;
  if x+ x2> hXSize then x2:= hXSize- x;
  if y+ y2> hYSize then y2:= hYSize- y;
  if x< 0 then begin
    inc(x1, -x);
    x:= 0;
  end;
  if y< 0 then begin
    inc(y1, -y);
    y:= 0;
  end;

  srcRect.Left:= x1;
  srcRect.Top:= y1;
  srcRect.Right:= x2;
  srcRect.Bottom:= y2;

  while (true) do begin
    hRet:= DDBackSurface.BltFast(x, y, DDSurface, @srcRect, 0);
    if hRet= DD_OK then begin
      FlipBackToPrimary;
      exit;
    end;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit to THyper64, using color keying
procedure TBuffer64.DrawSprite(x, y : LongInt; key : LongWord);
var
  srcRect : TRect;
  hRet : HResult;
  x1, y1 : LongInt;
  x2, y2 : LongInt;
  ColorKey : TDDColorKey;
begin
  if not Assigned(Self) then exit;
  if (x> hXSize) or (y> hYSize) then exit;
  if (x+ XSize< 0) or (y+ YSize< 0) then exit;

  x1:= 0;
  y1:= 0;
  x2:= XSize;
  y2:= YSize;
  if x+ x2> hXSize then x2:= hXSize- x;
  if y+ y2> hYSize then y2:= hYSize- y;
  if x< 0 then begin
    inc(x1, -x);
    x:= 0;
  end;
  if y< 0 then begin
    inc(y1, -y);
    y:= 0;
  end;

  srcRect.Left:= x1;
  srcRect.Top:= y1;
  srcRect.Right:= x2;
  srcRect.Bottom:= y2;

  ColorKey.dwColorSpaceLowValue:= key;
  ColorKey.dwColorSpaceHighValue:= key;
  DDSurface.SetColorKey(DDCKEY_SRCBLT, @ColorKey);

  while (true) do begin
    hRet:= DDBackSurface.BltFast(x, y, DDSurface, @srcRect, DDBLTFAST_SRCCOLORKEY);
    if hRet= DD_OK then begin
      FlipBackToPrimary;
      exit;
    end;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit to TBuffer
procedure TBuffer64.Copy(Buffer : TBuffer64; x, y : LongInt);
var
  srcRect : TRect;
  hRet : HResult;
  x1, y1 : LongInt;
  x2, y2 : LongInt;
begin
  if not Assigned(Self) then exit;
  if (x> Buffer.XSize) or (y> Buffer.YSize) then exit;
  if (x+ XSize< 0) or (y+ YSize< 0) then exit;

  x1:= 0;
  y1:= 0;
  x2:= XSize;
  y2:= YSize;
  if x+ x2> Buffer.XSize then x2:= Buffer.XSize- x;
  if y+ y2> Buffer.YSize then y2:= Buffer.YSize- y;
  if x< 0 then begin
    inc(x1, -x);
    x:= 0;
  end;
  if y< 0 then begin
    inc(y1, -y);
    y:= 0;
  end;

  srcRect.Left:= x1;
  srcRect.Top:= y1;
  srcRect.Right:= x2;
  srcRect.Bottom:= y2;

  while (true) do begin
    hRet:= Buffer.DDSurface.BltFast(x, y, DDSurface, @srcRect, 0);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit to THyper64, using color keying
procedure TBuffer64.CopySprite(Buffer : TBuffer64; x, y : LongInt; key : LongWord);
var
  srcRect : TRect;
  hRet : HResult;
  x1, y1 : LongInt;
  x2, y2 : LongInt;
  ColorKey : TDDColorKey;
begin
  if not Assigned(Self) then exit;
  if (x> Buffer.XSize) or (y> Buffer.YSize) then exit;
  if (x+ XSize< 0) or (y+ YSize< 0) then exit;

  x1:= 0;
  y1:= 0;
  x2:= XSize;
  y2:= YSize;
  if x+ x2> Buffer.XSize then x2:= Buffer.XSize- x;
  if y+ y2> Buffer.YSize then y2:= Buffer.YSize- y;
  if x< 0 then begin
    inc(x1, -x);
    x:= 0;
  end;
  if y< 0 then begin
    inc(y1, -y);
    y:= 0;
  end;

  srcRect.Left:= x1;
  srcRect.Top:= y1;
  srcRect.Right:= x2;
  srcRect.Bottom:= y2;

  ColorKey.dwColorSpaceLowValue:= key;
  ColorKey.dwColorSpaceHighValue:= key;
  DDSurface.SetColorKey(DDCKEY_SRCBLT, @ColorKey);

  while (true) do begin
    hRet:= Buffer.DDSurface.BltFast(x, y, DDSurface, @srcRect, DDBLTFAST_SRCCOLORKEY);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit a rectangle from TBuffer64 to THyper64
procedure TBuffer64.DrawBit(x1, y1, x2, y2, x, y : LongInt);
var
  srcRect : TRect;
  hRet : HResult;
  sx, sy : longint;
  tmp : longint;
begin
  if not Assigned(Self) then exit;

  if (x> hXSize) or (y> hYSize) then exit;
  if (x+ XSize< 0) or (y+ YSize< 0) then exit;

  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;

  if x1< 0 then x1:= 0;
  if y1< 0 then y1:= 0;
  if x2> XSize then x2:= XSize;
  if y2> YSize then y2:= YSize;

  sx:= x+ (x2- x1);
  sy:= y+ (y2- y1);
  if sx> hXSize then x2:= x2- (sx- hXSize);
  if sy> hYSize then y2:= y2- (sy- hYSize);
  if x< 0 then begin
    inc(x1, -x);
    x:= 0;
  end;
  if y< 0 then begin
    inc(y1, -y);
    y:= 0;
  end;

  srcRect.Left:= x1;
  srcRect.Top:= y1;
  srcRect.Right:= x2;
  srcRect.Bottom:= y2;

  while (true) do begin
    hRet:= DDBackSurface.BltFast(x, y, DDSurface, @srcRect, 0);
    if hRet= DD_OK then begin
      FlipBackToPrimary;
      exit;
    end;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit a rectangle from TBuffer64 to THyper64, using
// color keying
procedure TBuffer64.DrawBitSprite(x1, y1, x2, y2, x, y : LongInt; key : LongWord);
var
  srcRect : TRect;
  hRet : HResult;
  sx, sy : longint;
  ColorKey : TDDColorKey;
  tmp : longint;
begin
  if not Assigned(Self) then exit;

  if (x> hXSize) or (y> hYSize) then exit;
  if (x+ XSize< 0) or (y+ YSize< 0) then exit;

  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;

  if x1< 0 then x1:= 0;
  if y1< 0 then y1:= 0;
  if x2> XSize then x2:= XSize;
  if y2> YSize then y2:= YSize;

  sx:= x+ (x2- x1);
  sy:= y+ (y2- y1);
  if sx> hXSize then x2:= x2- (sx- hXSize);
  if sy> hYSize then y2:= y2- (sy- hYSize);
  if x< 0 then begin
    inc(x1, -x);
    x:= 0;
  end;
  if y< 0 then begin
    inc(y1, -y);
    y:= 0;
  end;

  srcRect.Left:= x1;
  srcRect.Top:= y1;
  srcRect.Right:= x2;
  srcRect.Bottom:= y2;

  ColorKey.dwColorSpaceLowValue:= key;
  ColorKey.dwColorSpaceHighValue:= key;
  DDSurface.SetColorKey(DDCKEY_SRCBLT, @ColorKey);

  while (true) do begin
    hRet:= DDBackSurface.BltFast(x, y, DDSurface, @srcRect, DDBLTFAST_SRCCOLORKEY);
    if hRet= DD_OK then begin
      FlipBackToPrimary;
      exit;
    end;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit a rectangle from TBuffer64 to TBuffer64
procedure TBuffer64.CopyBit(Buffer : TBuffer64; x1, y1, x2, y2, x, y : LongInt);
var
  srcRect : TRect;
  hRet : HResult;
  sx, sy : longint;
  tmp : longint;
begin
  if not Assigned(Self) then exit;

  if (x> Buffer.XSize) or (y> Buffer.YSize) then exit;
  if (x+ XSize< 0) or (y+ YSize< 0) then exit;

  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;

  if x1< 0 then x1:= 0;
  if y1< 0 then y1:= 0;
  if x2> XSize then x2:= XSize;
  if y2> YSize then y2:= YSize;

  sx:= x+ (x2- x1);
  sy:= y+ (y2- y1);
  if sx> Buffer.XSize then x2:= x2- (sx- Buffer.XSize);
  if sy> Buffer.YSize then y2:= y2- (sy- Buffer.YSize);
  if x< 0 then begin
    inc(x1, -x);
    x:= 0;
  end;
  if y< 0 then begin
    inc(y1, -y);
    y:= 0;
  end;

  srcRect.Left:= x1;
  srcRect.Top:= y1;
  srcRect.Right:= x2;
  srcRect.Bottom:= y2;

  while (true) do begin
    hRet:= Buffer.DDSurface.BltFast(x, y, DDSurface, @srcRect, 0);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit a rectangle from TBuffer64 to TBuffer64, using
// color keying
procedure TBuffer64.CopyBitSprite(Buffer : TBuffer64; x1, y1, x2, y2, x, y : LongInt; Key : LongWord);
var
  srcRect : TRect;
  hRet : HResult;
  sx, sy : longint;
  ColorKey : TDDColorKey;
  tmp : longint;
begin
  if not Assigned(Self) then exit;
  if (x> Buffer.XSize) or (y> Buffer.YSize) then exit;
  if (x+ XSize< 0) or (y+ YSize< 0) then exit;

  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;

  if x1< 0 then x1:= 0;
  if y1< 0 then y1:= 0;
  if x2> XSize then x2:= XSize;
  if y2> YSize then y2:= YSize;

  sx:= x+ (x2- x1);
  sy:= y+ (y2- y1);
  if sx> Buffer.XSize then x2:= x2- (sx- Buffer.XSize);
  if sy> Buffer.YSize then y2:= y2- (sy- Buffer.YSize);
  if x< 0 then begin
    inc(x1, -x);
    x:= 0;
  end;
  if y< 0 then begin
    inc(y1, -y);
    y:= 0;
  end;

  srcRect.Left:= x1;
  srcRect.Top:= y1;
  srcRect.Right:= x2;
  srcRect.Bottom:= y2;

  ColorKey.dwColorSpaceLowValue:= key;
  ColorKey.dwColorSpaceHighValue:= key;
  DDSurface.SetColorKey(DDCKEY_SRCBLT, @ColorKey);

  while (true) do begin
    hRet:= Buffer.DDSurface.BltFast(x, y, DDSurface, @srcRect, DDBLTFAST_SRCCOLORKEY);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit to THyper64 with Scaling
procedure TBuffer64.DrawScale(x1, y1, x2, y2 : LongInt);
var
  dstRect : TRect;
  srcRect : TRect;
  hRet : HResult;
  sx1, sy1,
  sx2, sy2, tmp : LongInt;
  xscale_f,
  yscale_f : Single;
begin
  if not Assigned(Self) then exit;
  if not RectIntersect(0, 0, hXSize, hYSize, x1, y1, x2, y2) then exit;
  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;
  sx1:= 0;
  sy1:= 0;
  sx2:= XSize;
  sy2:= YSize;
  xscale_f:= (x2- x1)/ (sx2- sx1);
  yscale_f:= (y2- y1)/ (sy2- sy1);

  if x2> hXSize then begin
    dec(sx2, round((x2- hXSize)/ xscale_f));
    x2:= hXSize;
  end;
  if y2> hYSize then begin
    dec(sy2, round((y2- hYSize)/ yscale_f));
    y2:= hYSize;
  end;
  if x1< 0 then begin
    sx1:= round(-x1/ xscale_f);
    x1:= 0;
  end;
  if y1< 0 then begin
    sy1:= round(-y1/ yscale_f);
    y1:= 0;
  end;

  srcRect.Left:= sx1;
  srcRect.Top:= sy1;
  srcRect.Right:= sx2;
  srcRect.Bottom:= sy2;

  dstRect.Left:= x1;
  dstRect.Top:= y1;
  dstRect.Right:= x2;
  dstRect.Bottom:= y2;

  while (true) do begin
    hRet:= DDBackSurface.Blt(@dstRect, DDSurface, @srcRect, 0, nil);
    if hRet= DD_OK then begin
      FlipBackToPrimary;
      exit;
    end;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit to THyper64 with Scaling and Color Keying
procedure TBuffer64.DrawScaleSprite(x1, y1, x2, y2 : LongInt; key : LongWord);
var
  dstRect : TRect;
  srcRect : TRect;
  hRet : HResult;
  sx1, sy1,
  sx2, sy2, tmp : LongInt;
  xscale_f,
  yscale_f : Single;
  ColorKey : TDDColorKey;
begin
  if not Assigned(Self) then exit;
  if not RectIntersect(0, 0, hXSize, hYSize, x1, y1, x2, y2) then exit;
  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;
  sx1:= 0;
  sy1:= 0;
  sx2:= XSize;
  sy2:= YSize;
  xscale_f:= (x2- x1)/ (sx2- sx1);
  yscale_f:= (y2- y1)/ (sy2- sy1);

  if x2> hXSize then begin
    dec(sx2, round((x2- hXSize)/ xscale_f));
    x2:= hXSize;
  end;
  if y2> hYSize then begin
    dec(sy2, round((y2- hYSize)/ yscale_f));
    y2:= hYSize;
  end;
  if x1< 0 then begin
    sx1:= round(-x1/ xscale_f);
    x1:= 0;
  end;
  if y1< 0 then begin
    sy1:= round(-y1/ yscale_f);
    y1:= 0;
  end;

  srcRect.Left:= sx1;
  srcRect.Top:= sy1;
  srcRect.Right:= sx2;
  srcRect.Bottom:= sy2;

  dstRect.Left:= x1;
  dstRect.Top:= y1;
  dstRect.Right:= x2;
  dstRect.Bottom:= y2;

  ColorKey.dwColorSpaceLowValue:= key;
  ColorKey.dwColorSpaceHighValue:= key;
  DDSurface.SetColorKey(DDCKEY_SRCBLT, @ColorKey);

  while (true) do begin
    hRet:= DDBackSurface.Blt(@dstRect, DDSurface, @srcRect, DDBLT_KEYSRC, nil);
    if hRet= DD_OK then begin
      FlipBackToPrimary;
      exit;
    end;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit to TBuffer64 with Scaling
procedure TBuffer64.CopyScale(Buffer : TBuffer64; x1, y1, x2, y2 : LongInt);
var
  dstRect : TRect;
  srcRect : TRect;
  hRet : HResult;
  sx1, sy1,
  sx2, sy2, tmp : LongInt;
  xscale_f,
  yscale_f : Single;
begin
  if not Assigned(Self) then exit;
  if not RectIntersect(0, 0, Buffer.XSize, Buffer.YSize, x1, y1, x2, y2) then exit;
  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;
  sx1:= 0;
  sy1:= 0;
  sx2:= XSize;
  sy2:= YSize;
  xscale_f:= (x2- x1)/ (sx2- sx1);
  yscale_f:= (y2- y1)/ (sy2- sy1);

  if x2> Buffer.XSize then begin
    dec(sx2, trunc((x2- Buffer.XSize)/ xscale_f));
    x2:= Buffer.XSize;
  end;
  if y2> Buffer.YSize then begin
    dec(sy2, trunc((y2- Buffer.YSize)/ yscale_f));
    y2:= Buffer.YSize;
  end;
  if x1< 0 then begin
    sx1:= trunc(-x1/ xscale_f);
    x1:= 0;
  end;
  if y1< 0 then begin
    sy1:= trunc(-y1/ yscale_f);
    y1:= 0;
  end;

  srcRect.Left:= sx1;
  srcRect.Top:= sy1;
  srcRect.Right:= sx2;
  srcRect.Bottom:= sy2;

  dstRect.Left:= x1;
  dstRect.Top:= y1;
  dstRect.Right:= x2;
  dstRect.Bottom:= y2;

  while (true) do begin
    hRet:= Buffer.DDSurface.Blt(@dstRect, DDSurface, @srcRect, 0, nil);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit to TBuffer64 with Scaling and Color Keying
procedure TBuffer64.CopyScaleSprite(Buffer : TBuffer64; x1, y1, x2, y2 : LongInt; key : LongWord);
var
  dstRect : TRect;
  srcRect : TRect;
  hRet : HResult;
  sx1, sy1,
  sx2, sy2, tmp : LongInt;
  xscale_f,
  yscale_f : Single;
  ColorKey : TDDColorKey;
begin
  if not Assigned(Self) then exit;
  if not RectIntersect(0, 0, Buffer.XSize, Buffer.YSize, x1, y1, x2, y2) then exit;
  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;
  sx1:= 0;
  sy1:= 0;
  sx2:= XSize;
  sy2:= YSize;
  xscale_f:= (x2- x1)/ (sx2- sx1);
  yscale_f:= (y2- y1)/ (sy2- sy1);

  if x2> Buffer.XSize then begin
    dec(sx2, trunc((x2- Buffer.XSize)/ xscale_f));
    x2:= Buffer.XSize;
  end;
  if y2> Buffer.YSize then begin
    dec(sy2, trunc((y2- Buffer.YSize)/ yscale_f));
    y2:= Buffer.YSize;
  end;
  if x1< 0 then begin
    sx1:= trunc(-x1/ xscale_f);
    x1:= 0;
  end;
  if y1< 0 then begin
    sy1:= trunc(-y1/ yscale_f);
    y1:= 0;
  end;

  srcRect.Left:= sx1;
  srcRect.Top:= sy1;
  srcRect.Right:= sx2;
  srcRect.Bottom:= sy2;

  dstRect.Left:= x1;
  dstRect.Top:= y1;
  dstRect.Right:= x2;
  dstRect.Bottom:= y2;

  ColorKey.dwColorSpaceLowValue:= key;
  ColorKey.dwColorSpaceHighValue:= key;
  DDSurface.SetColorKey(DDCKEY_SRCBLT, @ColorKey);

  while (true) do begin
    hRet:= Buffer.DDSurface.Blt(@dstRect, DDSurface, @srcRect, DDBLT_KEYSRC, nil);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Blit to TBuffer64 with Rotate and Scale
procedure TBuffer64.CopyRotate(Buffer : TBuffer64; cx, cy : LongInt; scale, angle : Single);
var
  mx, my : LongInt;
  PreCos, PreSin : Single;
  xc, yc, x, y, tx, ty : Single;
  i : LongInt;
  vlist : array of TVertex;
begin
  if not Assigned(Self) then exit;
  mx:= XSize shr 1;
  my:= YSize shr 1;

  SetLength(vlist, 4);
  vlist[0].x:= 0;
  vlist[0].y:= 0;
  vlist[0].u:= 0;
  vlist[0].v:= 0;

  vlist[1].x:= XSize;
  vlist[1].y:= 0;
  vlist[1].u:= XSize;
  vlist[1].v:= 0;

  vlist[2].x:= XSize;
  vlist[2].y:= YSize;
  vlist[2].u:= XSize;
  vlist[2].v:= YSize;

  vlist[3].x:= 0;
  vlist[3].y:= YSize;
  vlist[3].u:= 0;
  vlist[3].v:= YSize;

  PreCos:= cos((angle/ 180)* Pi)* scale;
  PreSin:= sin((angle/ 180)* Pi)* scale;
  for i:= 0 to 3 do begin
    xc:= vlist[i].x- mx;
    yc:= vlist[i].y- my;
    x:= (xc* PreCos)- (yc* PreSin);
    y:= (xc* PreSin)+ (yc* PreCos);
    vlist[i].x:= x+ cx;
    vlist[i].y:= y+ cy;
  end;

  Buffer.TexturePoly(Self, vlist, 4);
end;

//========================================================
// Blit to TBuffer64 with Rotate, Scale and Color Keying
procedure TBuffer64.CopyRotateSprite(Buffer : TBuffer64; cx, cy : LongInt; scale, angle : Single; key : LongWord);
var
  mx, my : LongInt;
  PreCos, PreSin : Single;
  xc, yc, x, y, tx, ty : Single;
  i : LongInt;
  vlist : array of TVertex;
begin
  if not Assigned(Self) then exit;
  mx:= XSize shr 1;
  my:= YSize shr 1;

  SetLength(vlist, 4);
  vlist[0].x:= 0;
  vlist[0].y:= 0;
  vlist[0].u:= 0;
  vlist[0].v:= 0;

  vlist[1].x:= XSize;
  vlist[1].y:= 0;
  vlist[1].u:= XSize;
  vlist[1].v:= 0;

  vlist[2].x:= XSize;
  vlist[2].y:= YSize;
  vlist[2].u:= XSize;
  vlist[2].v:= YSize;

  vlist[3].x:= 0;
  vlist[3].y:= YSize;
  vlist[3].u:= 0;
  vlist[3].v:= YSize;

  PreCos:= cos((angle/ 180)* Pi)* scale;
  PreSin:= sin((angle/ 180)* Pi)* scale;
  for i:= 0 to 3 do begin
    xc:= vlist[i].x- mx;
    yc:= vlist[i].y- my;
    x:= (xc* PreCos)- (yc* PreSin);
    y:= (xc* PreSin)+ (yc* PreCos);
    vlist[i].x:= x+ cx;
    vlist[i].y:= y+ cy;
  end;

  Buffer.KeyTexturePoly(Self, vlist, 4, key);
end;

//========================================================
// Copy Buffer using Additive/Saturated blending
procedure TBuffer64.CopyAdd(Buffer : TBuffer64; x, y : LongInt);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
begin
  if not Assigned(Self) then exit;
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;
  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           add_line16(ptr_s16, ptr_d16, sizex, s_xi, x1);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           add_line24(ptr_s24, ptr_d24, sizex, s_xi, x1);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           add_line32(ptr_s32, ptr_d32, sizex, s_xi, x1);
         end;
  end;
end;

//========================================================
// Copy Buffer using Subtractive blending
procedure TBuffer64.CopySub(Buffer : TBuffer64; x, y : LongInt);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
begin
  if not Assigned(Self) then exit;
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;
  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           sub_line16(ptr_s16, ptr_d16, sizex, s_xi, x1);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           sub_line24(ptr_s24, ptr_d24, sizex, s_xi, x1);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           sub_line32(ptr_s32, ptr_d32, sizex, s_xi, x1);
         end;
  end;
end;

//========================================================
// Copy Buffer using Xor operation
procedure TBuffer64.CopyXor(Buffer : TBuffer64; x, y : LongInt);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
begin
  if not Assigned(Self) then exit;
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;
  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           xor_line16(ptr_s16, ptr_d16, sizex, s_xi, x1);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           xor_line24(ptr_s24, ptr_d24, sizex, s_xi, x1);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           xor_line32(ptr_s32, ptr_d32, sizex, s_xi, x1);
         end;
  end;
end;

//========================================================
// Copy Buffer using Alpha blending
procedure TBuffer64.CopyAlpha(Buffer : TBuffer64; x, y : LongInt; alpha : byte);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2, i,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
  AlphaTable : PAlphaTable;
begin
  if not Assigned(Self) then exit;
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;

  New(AlphaTable);
  for i:= -255 to 255 do
    AlphaTable^[i]:= i* (255- alpha) shr 8;
  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           alpha_line16(ptr_s16, ptr_d16, sizex, s_xi, x1, AlphaTable);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           alpha_line24(ptr_s24, ptr_d24, sizex, s_xi, x1, AlphaTable);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           alpha_line32(ptr_s32, ptr_d32, sizex, s_xi, x1, AlphaTable);
         end;
  end;
  Dispose(AlphaTable);
end;

//========================================================
// Copy Buffer using Alpha blending
procedure TBuffer64.CopyAlphaMap(Buffer : TBuffer64; x, y : LongInt);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2, i,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
begin
  if not Assigned(Self) then exit;
  if not usesAlpha then exit;
  
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;

  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           alphamap_line16(ptr_s16, ptr_d16, sizex, s_xi, x1, AlphaLines[y]);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           alphamap_line24(ptr_s24, ptr_d24, sizex, s_xi, x1, AlphaLines[y]);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           alphamap_line32(ptr_s32, ptr_d32, sizex, s_xi, x1, AlphaLines[y]);
         end;
  end;
end;

//========================================================
// Copy Buffer using Alpha blending and color keying
procedure TBuffer64.CopyAlphaSprite(Buffer : TBuffer64; x, y : LongInt; alpha : byte; key : longword);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2, i,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
  AlphaTable : PAlphaTable;
begin
  if not Assigned(Self) then exit;
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;

  New(AlphaTable);
  for i:= -255 to 255 do
    AlphaTable^[i]:= i* (255- alpha) shr 8;
  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           alphakey_line16(ptr_s16, ptr_d16, sizex, s_xi, x1, AlphaTable, key);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           alphakey_line24(ptr_s24, ptr_d24, sizex, s_xi, x1, AlphaTable, key);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           alphakey_line32(ptr_s32, ptr_d32, sizex, s_xi, x1, AlphaTable, key);
         end;
  end;
  Dispose(AlphaTable);
end;

//========================================================
// Copy Red component channel
procedure TBuffer64.CopyRedChannel(Buffer : TBuffer64; x, y : LongInt);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2, i,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
begin
  if not Assigned(Self) then exit;
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;

  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           extractred_line16(ptr_s16, ptr_d16, sizex, s_xi, x1);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           extractred_line24(ptr_s24, ptr_d24, sizex, s_xi, x1);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           extractred_line32(ptr_s32, ptr_d32, sizex, s_xi, x1);
         end;
  end;
end;

//========================================================
// Copy Green component channel
procedure TBuffer64.CopyGreenChannel(Buffer : TBuffer64; x, y : LongInt);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2, i,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
begin
  if not Assigned(Self) then exit;
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;

  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           extractgreen_line16(ptr_s16, ptr_d16, sizex, s_xi, x1);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           extractgreen_line24(ptr_s24, ptr_d24, sizex, s_xi, x1);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           extractgreen_line32(ptr_s32, ptr_d32, sizex, s_xi, x1);
         end;
  end;
end;

//========================================================
// Copy Blue component channel
procedure TBuffer64.CopyBlueChannel(Buffer : TBuffer64; x, y : LongInt);
var
  ptr_s16, ptr_d16 : pline16;
  ptr_s24, ptr_d24 : pline24;
  ptr_s32, ptr_d32 : pline8;
  x1, y1, x2, y2, i,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
begin
  if not Assigned(Self) then exit;
  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;

  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_s16:= Lines[s_yi+ y];
           ptr_d16:= Buffer.Lines[y1+ y];
           extractblue_line16(ptr_s16, ptr_d16, sizex, s_xi, x1);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_s24:= Lines[s_yi+ y];
           ptr_d24:= Buffer.Lines[y1+ y];
           extractblue_line24(ptr_s24, ptr_d24, sizex, s_xi, x1);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_s32:= Lines[s_yi+ y];
           ptr_d32:= Buffer.Lines[y1+ y];
           extractblue_line32(ptr_s32, ptr_d32, sizex, s_xi, x1);
         end;
  end;
end;

//========================================================
// Copy Alpha component channel
procedure TBuffer64.CopyAlphaChannel(Buffer : TBuffer64; x, y : LongInt);
var
  ptr_d16 : pline16;
  ptr_d24 : pline24;
  ptr_d32 : pline8;
  x1, y1, x2, y2, i,
  sizex, sizey : longint;
  s_xi, s_yi : longint;
begin
  if not Assigned(Self) then exit;
  if not usesAlpha then exit;

  if x> Buffer.XMax then exit;
  if y> Buffer.YMax then exit;
  if x+ xsize< 0 then exit;
  if y+ ysize< 0 then exit;

  x1:= x;
  y1:= y;
  x2:= x1+ xsize;
  y2:= y1+ ysize;

  s_xi:= 0;
  s_yi:= 0;
  if x1< 0 then begin
    s_xi:= -x1;
    x1:= 0;
  end;
  if y1< 0 then begin
    s_yi:= -y1;
    y1:= 0;
  end;
  if x2> Buffer.XSize then x2:= Buffer.XSize;
  if y2> Buffer.YSize then y2:= Buffer.YSize;

  sizex:= x2- x1;
  if sizex<= 0 then exit;
  sizey:= y2- y1;
  if sizey<= 0 then exit;

  case hBpp of
    16 : for y:= 0 to sizey- 1 do begin
           ptr_d16:= Buffer.Lines[y1+ y];
           extractalpha_line16(AlphaLines[s_yi+ y], ptr_d16, sizex, s_xi, x1);
         end;
    24 : for y:= 0 to sizey- 1 do begin
           ptr_d24:= Buffer.Lines[y1+ y];
           extractalpha_line24(AlphaLines[s_yi+ y], ptr_d24, sizex, s_xi, x1);
         end;
    32 : for y:= 0 to sizey- 1 do begin
           ptr_d32:= Buffer.Lines[y1+ y];
           extractalpha_line32(AlphaLines[s_yi+ y], ptr_d32, sizex, s_xi, x1);
         end;
  end;
end;

//========================================================
// Apply Blur 2x filter to Buffer
procedure TBuffer64.Blur2x;
begin
  if not Assigned(Self) then exit;
  case hBpp of
    16 : Blur2x_16(Self);
    24 : Blur2x_24(Self);
    32 : Blur2x_32(Self);
  end;
end;

//========================================================
// Negative filter to Buffer
procedure TBuffer64.Negative;
begin
  if not Assigned(Self) then exit;
  case hBpp of
    16 : Negative_16(Self);
    24 : Negative_24(Self);
    32 : Negative_32(Self);
  end;
end;

//========================================================
// Greyscale filter to Buffer
procedure TBuffer64.Greyscale;
begin
  if not Assigned(Self) then exit;
  case hBpp of
    16 : Greyscale_16(Self);
    24 : Greyscale_24(Self);
    32 : Greyscale_32(Self);
  end;
end;

//========================================================
// Draw a Flat color Polygon
procedure TBuffer64.FlatPoly(VertexList : array of TVertex; NumVertex : LongInt; color : LongWord);

  procedure ScanEdge(x1, y1, x2, y2 : single);
  var
    side : LongInt;
    y, x, fy, ly : LongInt;
    xslope, tmp, dx, dy : single;
    fxslope : LongInt;
  begin
    side:= 0;
    dx:= x2- x1;
	  dy:= y2- y1;
	  if dy<> 0 then xslope:= dx/ dy;
	  if (y1> y2) then begin
	    side:= 1;
	    tmp:= x1;
	    x1:= x2;
	    x2:= tmp;
	    tmp:= y1;
	    y1:= y2;
	    y2:= tmp;
    end;

    fy:= Ceil(y1);
 	  ly:= Ceil(y2)- 1;
    x:= Trunc((x1+ (fy- y1)* xslope)* 65536);
    fxslope:= Trunc(xslope* 65536);
    for y:= fy to ly do begin
      if (y> YMax) then exit;
      if y>= 0 then XEdge[side, y]:= x div 65536;
      x:= x+ fxslope;
    end;
  end;

var
  x1, y1, x2, y2,
  pYMax, pYMin : single;
  y, ys, ye : LongInt;
begin
  if not Assigned(Self) then exit;
  pYMin:= YMax;
  pYMax:= 0;
  for y:= 1 to NumVertex- 1 do begin
    x1:= VertexList[y- 1].x;
    y1:= VertexList[y- 1].y;
    x2:= VertexList[y].x;
    y2:= VertexList[y].y;
    ScanEdge(x1, y1, x2, y2);
    if pYMin> y2 then pYMin:= y2;
    if pYMax< y2 then pYMax:= y2;
  end;

  dec(y);
  x1:= VertexList[y].x;
	y1:= VertexList[y].y;
	x2:= VertexList[0].x;
	y2:= VertexList[0].y;
	ScanEdge(x1, y1, x2, y2);
  if pYMin> y2 then pYMin:= y2;
  if pYMax< y2 then pYMax:= y2;

	if pYMin<> pYMax then begin
    ys:= Ceil(pYMin);
    ye:= Ceil(pYMax)- 1;
    if ye> YMax then ye:= YMax;
    if ys< 0 then ys:= 0;
    for y:= ys to ye do begin
      if y< 0 then continue;
		  HLine(XEdge[0, y], XEdge[1, y], y, color);
    end;
  end;
end;

//========================================================
// Draws a Gouraud color Polygon, also used fo shaded funcs
procedure TBuffer64.GouraudPoly(VertexList : array of TVertex; NumVertex : LongInt);
var
  YLine16 : PLine16;
  YLine24 : PLine24;
  YLine32 : PLine32;
  tr, tg, tb : byte;
  r1, g1, b1,
  r2, g2, b2 : LongInt;

  procedure ScanEdge(x1, y1, x2, y2 : single; c1, c2 : longword);
  var
    side : LongInt;
    tmpl : LongWord;
    y, x, r, g, b, fy, ly : LongInt;
    xslope, rslope, gslope, bslope,
    tmp, dx, dy : single;
    fxslope, frslope, fgslope, fbslope : LongInt;
  begin
    side:= 0;

    UnRGB(c1, tr, tg, tb);
    r1:= LongInt(tr);
    g1:= LongInt(tg);
    b1:= LongInt(tb);
    UnRGB(c2, tr, tg, tb);
    r2:= LongInt(tr);
    g2:= LongInt(tg);
    b2:= LongInt(tb);

    dx:= x2- x1;
	  dy:= y2- y1;
	  if dy<> 0 then begin
      xslope:= dx/ dy;
      rslope:= (r2- r1)/ dy;
      gslope:= (g2- g1)/ dy;
      bslope:= (b2- b1)/ dy;
    end;
	  if (y1> y2) then begin
	    side:= 1;
	    tmp:= x1;
	    x1:= x2;
	    x2:= tmp;
	    tmp:= y1;
	    y1:= y2;
	    y2:= tmp;

      tmpl:= r1;
	    r1:= r2;
	    r2:= tmpl;
      tmpl:= g1;
	    g1:= g2;
	    g2:= tmpl;
      tmpl:= b1;
	    b1:= b2;
	    b2:= tmpl;
    end;

    fy:= Ceil(y1);
 	  ly:= Ceil(y2)- 1;
    x:= Trunc((x1+ (fy- y1)* xslope)* 65536);
    r:= Trunc((r1+ (fy- y1)* rslope)* 65536);
    g:= Trunc((g1+ (fy- y1)* gslope)* 65536);
    b:= Trunc((b1+ (fy- y1)* bslope)* 65536);
    fxslope:= Trunc(xslope* 65536);
    frslope:= Trunc(rslope* 65536);
    fgslope:= Trunc(gslope* 65536);
    fbslope:= Trunc(bslope* 65536);
    for y:= fy to ly do begin
      if (y> YMax) then exit;
      if y>= 0 then begin
        XEdge[side, y]:= x div 65536;
        RGBEdge[side, y].r:= r;
        RGBEdge[side, y].g:= g;
        RGBEdge[side, y].b:= b;
      end;
      x:= x+ fxslope;
      r:= r+ frslope;
      g:= g+ fgslope;
      b:= b+ fbslope;
    end;
  end;

  procedure GouraudLine(x1, x2, y : LongInt);
  var
    x, tmp : LongInt;
    rslope, gslope, bslope, dx : LongInt;
  begin
    r1:= RGBEdge[0, y].r;
    g1:= RGBEdge[0, y].g;
    b1:= RGBEdge[0, y].b;
    r2:= RGBEdge[1, y].r;
    g2:= RGBEdge[1, y].g;
    b2:= RGBEdge[1, y].b;

    if (x1> x2) then begin
	    tmp:= x1;
	    x1:= x2;
	    x2:= tmp;

	    tmp:= r1;
	    r1:= r2;
	    r2:= tmp;
      tmp:= g1;
	    g1:= g2;
	    g2:= tmp;
      tmp:= b1;
	    b1:= b2;
	    b2:= tmp;
    end;
    if (x2< 0) then exit;
    if (x1> XMax) then exit;
    dx:= (x2- x1);
    if dx<> 0 then begin
      rslope:= (r2- r1) div dx;
      gslope:= (g2- g1) div dx;
      bslope:= (b2- b1) div dx;
    end;
    if (x2> XMax) then x2:= XMax;
    if (x2- x1)<= 0 then exit;

    if Bitpp= 16 then begin
      YLine16:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then YLine16[x]:= RGB(r1 div 65536, g1 div 65536, b1 div 65536);
        r1:= r1+ rslope;
        g1:= g1+ gslope;
        b1:= b1+ bslope;
      end;
    end
    else if Bitpp= 24 then begin
      YLine24:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then begin
          YLine24[x].r:= r1 div 65536;
          YLine24[x].g:= g1 div 65536;
          YLine24[x].b:= b1 div 65536;
        end;
        r1:= r1+ rslope;
        g1:= g1+ gslope;
        b1:= b1+ bslope;
      end;
    end
    else if Bitpp= 32 then begin
      YLine32:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then YLine32[x]:= RGB(r1 div 65536, g1 div 65536, b1 div 65536);
        r1:= r1+ rslope;
        g1:= g1+ gslope;
        b1:= b1+ bslope;
      end;
    end;
  end;

var
  x1, y1, x2, y2,
  pYMax, pYMin : single;
  y, ys, ye : LongInt;
begin
  if not Assigned(Self) then exit;
  pYMin:= YMax;
  pYMax:= 0;
  for y:= 1 to NumVertex- 1 do begin
    x1:= VertexList[y- 1].x;
    y1:= VertexList[y- 1].y;
    x2:= VertexList[y].x;
    y2:= VertexList[y].y;
    ScanEdge(x1, y1, x2, y2, VertexList[y- 1].color, VertexList[y].color);
    if pYMin> y2 then pYMin:= y2;
    if pYMax< y2 then pYMax:= y2;
  end;

  dec(y);
  x1:= VertexList[y].x;
	y1:= VertexList[y].y;
	x2:= VertexList[0].x;
	y2:= VertexList[0].y;
	ScanEdge(x1, y1, x2, y2, VertexList[y].color, VertexList[0].color);
  if pYMin> y2 then pYMin:= y2;
  if pYMax< y2 then pYMax:= y2;

	if pYMin<> pYMax then begin
    ys:= Ceil(pYMin);
    ye:= Ceil(pYMax)- 1;
    if ye> YMax then ye:= YMax;
    if ys< 0 then ys:= 0;
    for y:= ys to ye do begin
      if y< 0 then continue;

		  GouraudLine(XEdge[0, y], XEdge[1, y], y);
    end;
  end;
end;

//========================================================
// Draw a Texture Mapped Polygon, also used for rotation
procedure TBuffer64.TexturePoly(Texture : TBuffer64; VertexList : array of TVertex; NumVertex : LongInt);
var
  YLine16 : PLine16;
  YLine24 : PLine24;
  YLine32 : PLine32;

  procedure ScanEdge(x1, y1, x2, y2, u1, v1, u2, v2 : single);
  var
    side : LongInt;
    y, x, u, v, fy, ly : LongInt;
    xslope, uslope, vslope,
    tmp, dx, dy : single;
    fxslope, fuslope, fvslope : LongInt;
  begin
    side:= 0;
    dx:= x2- x1;
	  dy:= y2- y1;
	  if dy<> 0 then begin
	    xslope:= dx/ dy;
	    uslope:= (u2- u1)/ dy;
	    vslope:= (v2- v1)/ dy;
	  end;
	  if (y1> y2) then begin
	    side:= 1;
	    tmp:= x1;
	    x1:= x2;
	    x2:= tmp;
	    tmp:= y1;
	    y1:= y2;
	    y2:= tmp;
	    tmp:= u1;
	    u1:= u2;
	    u2:= tmp;
	    tmp:= v1;
	    v1:= v2;
	    v2:= tmp;
    end;

    fy:= Ceil(y1);
 	  ly:= Ceil(y2)- 1;
    x:= Trunc((x1+ (fy- y1)* xslope)* 65536);
    u:= Trunc((u1+ (fy- y1)* uslope)* 65536);
    v:= Trunc((v1+ (fy- y1)* vslope)* 65536);
    fxslope:= Trunc(xslope* 65536);
    fuslope:= Trunc(uslope* 65536);
    fvslope:= Trunc(vslope* 65536);
    for y:= fy to ly do begin
      if (y> YMax) then exit;
      if y>= 0 then begin
        XEdge[side, y]:= x div 65536;
        TexEdge[side, y].u:= u;
        TexEdge[side, y].v:= v;
      end;
      x:= x+ fxslope;
      u:= u+ fuslope;
      v:= v+ fvslope;
    end;
  end;

  procedure TextureLine(x1, x2, y : LongInt);
  var
    x, u, v, tmp : LongInt;
    uslope, vslope, dx,
    u1, v1, u2, v2 : LongInt;
  begin
    u1:= TexEdge[0, y].u;
    u2:= TexEdge[1, y].u;
    v1:= TexEdge[0, y].v;
    v2:= TexEdge[1, y].v;
    if (x1> x2) then begin
	    tmp:= x1;
	    x1:= x2;
	    x2:= tmp;
	    tmp:= u1;
	    u1:= u2;
	    u2:= tmp;
      tmp:= v1;
	    v1:= v2;
	    v2:= tmp;
    end;
    if (x2< 0) then exit;
    if (x1> XMax) then exit;
    dx:= (x2- x1);
    if dx<> 0 then begin
      uslope:= (u2- u1) div dx;
      vslope:= (v2- v1) div dx;
    end;
    if (x2> XMax) then x2:= XMax;
    if (x2- x1)<= 0 then exit;

    if Bitpp= 16 then begin
      YLine16:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then begin
          v:= v1 div 65536;
          u:= u1 div 65536;
          if v> texture.ymax then dec(v);
          if u> texture.xmax then dec(u);
          YLine16[x]:= Texture.Pixels16[v][u];
        end;
        u1:= u1+ uslope;
        v1:= v1+ vslope;
      end;
    end
    else if Bitpp= 24 then begin
      YLine24:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then begin
          v:= v1 div 65536;
          if v> texture.ymax then dec(v);
          YLine24[x]:= Texture.Pixels24[v][u1 div 65536];
        end;
        u1:= u1+ uslope;
        v1:= v1+ vslope;
      end;
    end
    else if Bitpp= 32 then begin
      YLine32:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then begin
          v:= v1 div 65536;
          if v> texture.ymax then dec(v);
          YLine32[x]:= Texture.Pixels32[v][u1 div 65536];
        end;
        u1:= u1+ uslope;
        v1:= v1+ vslope;
      end;
    end;
  end;

var
  x1, y1, x2, y2,
  pYMax, pYMin : single;
  y, ys, ye : LongInt;
begin
  if not Assigned(Self) then exit;
  pYMin:= YMax;
  pYMax:= 0;
  for y:= 1 to NumVertex- 1 do begin
    x1:= VertexList[y- 1].x;
    y1:= VertexList[y- 1].y;
    x2:= VertexList[y].x;
    y2:= VertexList[y].y;
    ScanEdge(x1, y1, x2, y2, VertexList[y- 1].u, VertexList[y- 1].v,
                             VertexList[y].u, VertexList[y].v);
    if pYMin> y2 then pYMin:= y2;
    if pYMax< y2 then pYMax:= y2;
  end;

  dec(y);
  x1:= VertexList[y].x;
	y1:= VertexList[y].y;
	x2:= VertexList[0].x;
	y2:= VertexList[0].y;
	ScanEdge(x1, y1, x2, y2, VertexList[y].u, VertexList[y].v,
                           VertexList[0].u, VertexList[0].v);
  if pYMin> y2 then pYMin:= y2;
  if pYMax< y2 then pYMax:= y2;

	if pYMin<> pYMax then begin
    ys:= Ceil(pYMin);
    ye:= Ceil(pYMax)- 1;
    if ye> YMax then ye:= YMax;
    if ys< 0 then ys:= 0;
    for y:= ys to ye do begin
      if y< 0 then continue;
		  TextureLine(XEdge[0, y], XEdge[1, y], y);
    end;
  end;
end;

//========================================================
// Draw a Texture Mapped Polygon using Color Keying, also used for rotation
procedure TBuffer64.KeyTexturePoly(Texture : TBuffer64; VertexList : array of TVertex; NumVertex : LongInt; key : LongWord);
var
  YLine16 : PLine16;
  YLine24 : PLine24;
  YLine32 : PLine32;
  Key24   : TBGR;
  tex_col24 : TBGR;

  procedure ScanEdge(x1, y1, x2, y2, u1, v1, u2, v2 : single);
  var
    side : LongInt;
    y, x, u, v, fy, ly : LongInt;
    xslope, uslope, vslope,
    tmp, dx, dy : single;
    fxslope, fuslope, fvslope : LongInt;
  begin
    side:= 0;
    dx:= x2- x1;
	  dy:= y2- y1;
	  if dy<> 0 then begin
	    xslope:= dx/ dy;
	    uslope:= (u2- u1)/ dy;
	    vslope:= (v2- v1)/ dy;
	  end;
	  if (y1> y2) then begin
	    side:= 1;
	    tmp:= x1;
	    x1:= x2;
	    x2:= tmp;
	    tmp:= y1;
	    y1:= y2;
	    y2:= tmp;
	    tmp:= u1;
	    u1:= u2;
	    u2:= tmp;
	    tmp:= v1;
	    v1:= v2;
	    v2:= tmp;
    end;

    fy:= Ceil(y1);
 	  ly:= Ceil(y2)- 1;
    x:= Trunc((x1+ (fy- y1)* xslope)* 65536);
    u:= Trunc((u1+ (fy- y1)* uslope)* 65536);
    v:= Trunc((v1+ (fy- y1)* vslope)* 65536);
    fxslope:= Trunc(xslope* 65536);
    fuslope:= Trunc(uslope* 65536);
    fvslope:= Trunc(vslope* 65536);
    for y:= fy to ly do begin
      if (y> YMax) then exit;
      if y>= 0 then begin
        XEdge[side, y]:= x div 65536;
        TexEdge[side, y].u:= u;
        TexEdge[side, y].v:= v;
      end;
      x:= x+ fxslope;
      u:= u+ fuslope;
      v:= v+ fvslope;
    end;
  end;

  procedure TextureLine(x1, x2, y : LongInt);
  var
    x, u, v, tmp : LongInt;
    uslope, vslope, dx,
    u1, v1, u2, v2 : LongInt;
    tex_col : LongWord;
    r, g, b : byte;
  begin
    u1:= TexEdge[0, y].u;
    u2:= TexEdge[1, y].u;
    v1:= TexEdge[0, y].v;
    v2:= TexEdge[1, y].v;
    if (x1> x2) then begin
	    tmp:= x1;
	    x1:= x2;
	    x2:= tmp;
	    tmp:= u1;
	    u1:= u2;
	    u2:= tmp;
      tmp:= v1;
	    v1:= v2;
	    v2:= tmp;
    end;
    if (x2< 0) then exit;
    if (x1> XMax) then exit;
    dx:= (x2- x1);
    if dx<> 0 then begin
      uslope:= (u2- u1) div dx;
      vslope:= (v2- v1) div dx;
    end;
    if (x2> XMax) then x2:= XMax;
    if (x2- x1)<= 0 then exit;

    if Bitpp= 16 then begin
      YLine16:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then begin
          v:= v1 div 65536;
          u:= u1 div 65536;
          if v> texture.ymax then dec(v);
          if u> texture.xmax then dec(u);
          tex_col:= Texture.Pixels16[v][u];
          if tex_col<> Key then YLine16[x]:= tex_col;
        end;
        u1:= u1+ uslope;
        v1:= v1+ vslope;
      end;
    end
    else if Bitpp= 24 then begin
      YLine24:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then begin
          v:= v1 div 65536;
          if v> texture.ymax then dec(v);
          tex_col24:= Texture.Pixels24[v][u1 div 65536];
          if (tex_col24.r<> Key24.r) or
             (tex_col24.g<> Key24.g) or
             (tex_col24.b<> Key24.b) then YLine24[x]:= tex_col24;
        end;
        u1:= u1+ uslope;
        v1:= v1+ vslope;
      end;
    end
    else if Bitpp= 32 then begin
      YLine32:= Lines[y];
      for x:= x1 to x2 do begin
        if x>= 0 then begin
          v:= v1 div 65536;
          if v> texture.ymax then dec(v);
          tex_col:= Texture.Pixels32[v][u1 div 65536];
          unrgb(tex_col, r, g, b);
          if (r<> Key24.r) or
             (g<> Key24.g) or
             (b<> Key24.b) then YLine32[x]:= tex_col;
        end;
        u1:= u1+ uslope;
        v1:= v1+ vslope;
      end;
    end;
  end;

var
  x1, y1, x2, y2,
  pYMax, pYMin : single;
  y, ys, ye : LongInt;
begin
  if not Assigned(Self) then exit;
  if bitpp in [24, 32] then UnRGB(Key, Key24.r, Key24.g, Key24.b);

  pYMin:= YMax;
  pYMax:= 0;
  for y:= 1 to NumVertex- 1 do begin
    x1:= VertexList[y- 1].x;
    y1:= VertexList[y- 1].y;
    x2:= VertexList[y].x;
    y2:= VertexList[y].y;
    ScanEdge(x1, y1, x2, y2, VertexList[y- 1].u, VertexList[y- 1].v,
                             VertexList[y].u, VertexList[y].v);
    if pYMin> y2 then pYMin:= y2;
    if pYMax< y2 then pYMax:= y2;
  end;

  dec(y);
  x1:= VertexList[y].x;
	y1:= VertexList[y].y;
	x2:= VertexList[0].x;
	y2:= VertexList[0].y;
	ScanEdge(x1, y1, x2, y2, VertexList[y].u, VertexList[y].v,
                           VertexList[0].u, VertexList[0].v);
  if pYMin> y2 then pYMin:= y2;
  if pYMax< y2 then pYMax:= y2;

	if pYMin<> pYMax then begin
    ys:= Ceil(pYMin);
    ye:= Ceil(pYMax)- 1;
    if ye> YMax then ye:= YMax;
    if ys< 0 then ys:= 0;
    for y:= ys to ye do begin
      if y< 0 then continue;
		  TextureLine(XEdge[0, y], XEdge[1, y], y);
    end;
  end;
end;

//========================================================
// Draws a Rectangle with 4 shaded colors
procedure TBuffer64.ShadedRect(x1, y1, x2, y2 : LongInt; topleft_color, topright_color, botleft_color, botright_color : LongWord);
var
  vlist : array of TVertex;
begin
  if not Assigned(Self) then exit;
  SetLength(vlist, 4);
  vlist[0].x:= x1;
  vlist[0].y:= y1;
  vlist[0].color:= topleft_color;

  vlist[1].x:= x2;
  vlist[1].y:= y1;
  vlist[1].color:= topright_color;

  vlist[2].x:= x2;
  vlist[2].y:= y2;
  vlist[2].color:= botright_color;

  vlist[3].x:= x1;
  vlist[3].y:= y2;
  vlist[3].color:= botleft_color;

  GouraudPoly(vlist, 4);
end;

//========================================================
// Clear
procedure TBuffer64.Fill(color : LongWord);
var
	bltfx : TDDBLTFX;
  hRet : HResult;
begin
  if not Assigned(Self) then exit;
	ZeroMemory(@bltfx, SizeOf(bltfx));
	bltfx.dwSize     := SizeOf(bltfx);
	bltfx.dwDDFX     := 0;
	bltfx.dwFillColor:= color;

  while (true) do begin
    hRet:= DDSurface.Blt(nil, nil, nil, DDBLT_COLORFILL, @bltfx);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Draw Pixel
procedure TBuffer64.PutPixel(x, y : LongInt; color : LongWord);
var col24 : TBGR;
begin
  if not Assigned(Self) then exit;
  if (x< 0) or (y< 0) or (x>= XSize) or (y>= YSize) then exit;
  case Bitpp of
    16 : Pixels16[y][x]:= color;
    24 : begin
           col24.r:= color shr 16;
           col24.g:= color shr 8;
           col24.b:= color;
           Pixels24[y][x]:= col24;
         end;
    32 : Pixels32[y][x]:= color;
  end;
end;

//========================================================
// Get Pixel Color
function TBuffer64.GetPixel(x, y : LongInt) : LongWord;
var col24 : TBGR;
begin
  if not Assigned(Self) then begin
    GetPixel:= 0;
    exit;
  end;
  if (x< 0) or (y< 0) or (x>= XSize) or (y>= YSize) then begin
    GetPixel:= 0;
    exit;
  end;
  case Bitpp of
    16 : GetPixel:= Pixels16[y][x];
    24 : begin
           col24:= Pixels24[y][x];
           GetPixel:= RGB(col24.r, col24.g, col24.b);
         end;
    32 : GetPixel:= Pixels32[y][x];
  else
    GetPixel:= 0;
  end;
end;

//========================================================
// Draw Line
procedure TBuffer64.Line(x1, y1, x2, y2 : LongInt; color : LongWord);
var
  D1x, D1y, D2x, D2y : LongInt;
  S, U, V, M, N, I : LongInt;
  col24 : TBGR;

  function Sgn(Val : LongInt) : LongInt;
  begin
    if val> 0 then Sgn:= 1
    else if val< 0 then Sgn:= -1
    else Sgn:= 0;
  end;

begin
  if not Assigned(Self) then exit;
  if ClipLine(x1, y1, x2, y2) then exit;

  if (x1= x2) and (y1= y2) then begin
    PutPixel(x1, y1, color);
    exit;
  end;
  U:= x2- x1;
  V:= y2- y1;
  D1x:= Sgn(U);
  D1y:= Sgn(V);
  D2x:= Sgn(U);
  D2y:= 0;
  M:= Abs(U);
  N:= Abs(V);
  if not (M> N) then begin
    D2x:= 0;
    D2y:= Sgn(V);
    M:= Abs(V);
    N:= Abs(U);
  end;
  S:= M shr 1;
  for i:= 0 to M do begin
    case Bitpp of
      16 : Pixels16[y1][x1]:= color;
      24 : begin
             col24.r:= color shr 16;
             col24.g:= color shr 8;
             col24.b:= color;
             Pixels24[y1][x1]:= col24;
          end;
      32 : Pixels32[y1][x1]:= color;
    end;

    inc(S, N);
    if not (S< M) then begin
      dec(S, M);
      inc(x1, D1x);
      inc(y1, D1y);
    end
    else begin
      inc(x1, D2x);
      inc(y1, D2y);
    end;
  end;
end;

//========================================================
// Draw Horizontal Line
procedure TBuffer64.HLine(x1, x2, y : LongInt; color : LongWord);
var
  tmp : LongInt;
  rt : TRect;
	bltfx : TDDBLTFX;
  hRet : HResult;
begin
  if not Assigned(Self) then exit;

  if (y< 0) or (y>= YSize) then exit;
  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  inc(x2);
  if x2< 0 then exit;
  if x1> XSize then exit;
  if x1< 0 then x1:= 0;
  if x2> XSize then x2:= XSize;

  rt.Left  := x1;
	rt.Top   := y;
	rt.Right := x2;
	rt.Bottom:= y+ 1;

	ZeroMemory(@bltfx, SizeOf(bltfx));
	bltfx.dwSize     := SizeOf(bltfx);
	bltfx.dwDDFX     := 0;
	bltfx.dwFillColor:= color;

  while (true) do begin
    hRet:= DDSurface.Blt(@rt, nil, nil, DDBLT_COLORFILL, @bltfx);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Draw Vertical Line
procedure TBuffer64.VLine(y1, y2, x : LongInt; color : LongWord);
var
  y, tmp : LongInt;
  col24 : TBGR;
begin
  if not Assigned(Self) then exit;
  if (x< 0) or (x>= XSize) then exit;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;
  if y2< 0 then exit;
  if y1>= YSize then exit;
  if y1< 0 then y1:= 0;
  if y2>= YSize then y2:= YSize- 1;

  case Bitpp of
    16 : for y:= y1 to y2 do Pixels16[y][x]:= color;
    24 : begin
           col24.r:= color shr 16;
           col24.g:= color shr 8;
           col24.b:= color;
           for y:= y1 to y2 do Pixels24[y][x]:= col24;
         end;
    32 : for y:= y1 to y2 do Pixels32[y][x]:= color;
  end;
end;

//========================================================
// Draw Rectangle
procedure TBuffer64.Rect(x1, y1, x2, y2 : LongInt; color : LongWord);
var tmp : longint;
begin
  if not Assigned(Self) then exit;
  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;
  HLine(x1, x2, y1, color);
  HLine(x1, x2, y2, color);
  VLine(y1, y2, x1, color);
  VLine(y1, y2, x2, color);
end;

//========================================================
// Draw Filled Rectangle
procedure TBuffer64.FillRect(x1, y1, x2, y2 : LongInt; color : LongWord);
var
  tmp : LongInt;
  rt : TRect;
	bltfx : TDDBLTFX;
  hRet : HResult;
begin
  if not Assigned(Self) then exit;
  if x1> x2 then begin
    tmp:= x2;
    x2:= x1;
    x1:= tmp;
  end;
  if y1> y2 then begin
    tmp:= y2;
    y2:= y1;
    y1:= tmp;
  end;

  if x2< 0 then exit;
  if y2< 0 then exit;
  if x1> XSize then exit;
  if y1> YSize then exit;
  if x1< 0 then x1:= 0;
  if y1< 0 then y1:= 0;
  if x2> XSize then x2:= XSize;
  if y2> YSize then y2:= YSize;

  rt.Left  := x1;
	rt.Top   := y1;
	rt.Right := x2+ 1;
	rt.Bottom:= y2+ 1;

	ZeroMemory(@bltfx, SizeOf(bltfx));
	bltfx.dwSize     := SizeOf(bltfx);
	bltfx.dwDDFX     := 0;
	bltfx.dwFillColor:= color;

  while (true) do begin
    hRet:= DDSurface.Blt(@rt, nil, nil, DDBLT_COLORFILL, @bltfx);
    if hRet= DD_OK then exit;
    if hRet= DDERR_SURFACELOST then begin
      RestoreAll;
      exit;
    end;
    if hRet<> DDERR_WASSTILLDRAWING then exit;
  end;
end;

//========================================================
// Draw Circle
procedure TBuffer64.Circle(x, y, r : LongInt; color : LongWord);
var delta, x1, y1 : LongInt;
begin
  if not Assigned(Self) then exit;
  delta:= 3- (r+ r);
  x1:= 0;
  y1:= r;
  if ((x+ r)< 0) then exit;
  if ((x- r)>= XSize) then exit;
  if ((y+ r)< 0) then exit;
  if ((y- r)>= YSize) then exit;
  while (x1<= y1) do begin
    PutPixel(x+ y1, y+ x1, color);
    PutPixel(x+ x1, y+ y1, color);
    PutPixel(x+ y1, y- x1, color);
    PutPixel(x+ x1, y- y1, color);
    PutPixel(x- y1, y+ x1, color);
    PutPixel(x- x1, y+ y1, color);
    PutPixel(x- y1, y- x1, color);
    PutPixel(x- x1, y- y1, color);
    if delta< 0 then begin
      inc(delta, (x1 shl 2)+ 6);
      inc(x1);
    end
    else begin
      inc(delta, (x1- y1) shl 2+ 10);
      inc(x1);
      dec(y1);
    end;
  end;
end;

//========================================================
// Draw Filled Circle
procedure TBuffer64.FillCircle(x, y, r : LongInt; color : LongWord);
var delta, x1, y1 : LongInt;
begin
  if not Assigned(Self) then exit;
  delta:= 3- (r+ r);
  x1:= 0;
  y1:= r;
  if ((x+ r)< 0) then exit;
  if ((x- r)>= XSize) then exit;
  if ((y+ r)< 0) then exit;
  if ((y- r)>= YSize) then exit;
  while (x1<= y1) do begin
    HLine(x+ y1, x- y1, y+ x1, color);
    HLine(x+ y1, x- y1, y- x1, color);
    HLine(x+ x1, x- x1, y+ y1, color);
    HLine(x+ x1, x- x1, y- y1, color);
    if delta< 0 then begin
      inc(delta, (x1 shl 2)+ 6);
      inc(x1);
    end
    else begin
      inc(delta, (x1- y1) shl 2+ 10);
      inc(x1);
      dec(y1);
    end;
  end;
end;

//========================================================
// Draw Ellipse
procedure TBuffer64.Ellipse(x, y, rx, ry : LongInt; color : LongWord);
var
  x1, dx1, dx2, dy1, dy2 : LongInt;
  xq, yq, dx, dy, r, xr, yr : LongInt;
begin
  if not Assigned(Self) then exit;
  if ((y+ rx)< 0) then exit;
  if ((y- rx)>= XSize) then exit;
  if ((y+ ry)< 0) then exit;
  if ((y- ry)>= YSize) then exit;
  PutPixel(x+ rx, y, color);
  PutPixel(x- rx, y, color);
  dx1:= x- rx;
  dy1:= y;
  dx2:= x+ rx;
  dy2:= y;
  xq:= rx* rx;
  yq:= ry* ry;
  dx:= xq shl 1;
  dy:= yq shl 1;
  r:= rx* yq;
  xr:= r shl 1;
  yr:= 0;
  x1:= rx;
  while x1> 0 do begin
    if r> 0 then begin
      inc(dy1);
      dec(dy2);
      inc(yr, Dx);
      dec(r, yr);
    end;
    if r<= 0 then begin
      dec(x1);
      inc(dx1);
      dec(dx2);
      dec(xr, Dy);
      inc(r, xr);
    end;
    PutPixel(dx1, dy2, color);
    PutPixel(dx2, dy2, color);
    PutPixel(dx1, dy1, color);
    PutPixel(dx2, dy1, color);
  end;
end;

//========================================================
// Draw Filled Ellipse
procedure TBuffer64.FillEllipse(x, y, rx, ry : LongInt; color : LongWord);
var
  x1, dx1, dx2, dy1, dy2 : LongInt;
  xq, yq, dx, dy, r, xr, yr : LongInt;
begin
  if not Assigned(Self) then exit;
  if ((y+ rx)< 0) then exit;
  if ((y- rx)>= XSize) then exit;
  if ((y+ ry)< 0) then exit;
  if ((y- ry)>= YSize) then exit;
  HLine(x- rx, x+ rx, y, color);
  dx1:= x- rx;
  dy1:= y;
  dx2:= x+ rx;
  dy2:= y;
  xq:= rx* rx;
  yq:= ry* ry;
  dx:= xq shl 1;
  dy:= yq shl 1;
  r:= rx* yq;
  xr:= r shl 1;
  yr:= 0;
  x1:= rx;
  while x1> 0 do begin
    if r> 0 then begin
      inc(dy1);
      dec(dy2);
      inc(yr, Dx);
      dec(r, yr);
    end;
    if r<= 0 then begin
      dec(x1);
      inc(dx1);
      dec(dx2);
      dec(xr, Dy);
      inc(r, xr);
    end;
    HLine(dx1, dx2, dy1, color);
    HLine(dx1, dx2, dy2, color);
  end;
end;

//========================================================
// Draw Cubic Bezier Line
procedure TBuffer64.CubicBezierLine(x1, y1, x2, y2, c1x, c1y, c2x, c2y, segments : LongInt; color : LongWord);
var
  i, x, y : LongInt;
  delta, time : single;
  lastx, lasty : LongInt;
  t1_1, t1_2, t1_3, t2, t3 : single;

  function GetBezier(p1, p2, c1, c2, time : single) : single;
  begin
    t1_1:= 1- time;
    t1_2:= t1_1* t1_1;
    t1_3:= t1_1* t1_2;
    t2:= time* time;
    t3:= t2* time;
    GetBezier:= t1_3* p1+ 3* time* t1_2* c1+ 3* t2* t1_1* c2+ t3* p2;
  end;

begin
  if not Assigned(Self) then exit;
  time:= 0;
  if segments= 0 then exit;
  delta:= 1/ segments;
  lastx:= round(GetBezier(x1, x2, c1x, c2x, time));
  lasty:= round(GetBezier(y1, y2, c1y, c2y, time));
  for i:= 0 to segments do begin
    x:= round(GetBezier(x1, x2, c1x, c2x, time));
    y:= round(GetBezier(y1, y2, c1y, c2y, time));
    time:= time+ delta;
    Line(x, y, lastx, lasty, color);
    lastx:= x;
    lasty:= y;
  end;
end;

//========================================================
// Clip Line - Cohen-Sutherland algorithm
function TBuffer64.ClipLine(var x1, y1, x2, y2 : LongInt) : Boolean;
const
  CodeBottom = 1;
  CodeTop    = 2;
  CodeLeft   = 4;
  CodeRight  = 8;

  function CompOutCode(x, y : Integer) : byte;
  var Code : byte;
  begin
    Code := 0;
    if y> YMax then Code:= CodeBottom
    else if y< 0 then Code:= CodeTop;
    if x> XMax then Code:= Code+CodeRight
    else if x< 0 then Code:= Code+CodeLeft;
    CompOutCode:= Code;
  end;

var
  OutCode0,
  OutCode1,
  OutCodeOut : Byte;
  x, y : Integer;
begin
  result:= false;
  OutCode0:= CompOutCode(X1, Y1);
  OutCode1:= CompOutCode(X2, Y2);

  while (OutCode0<> 0) or (OutCode1<> 0) DO begin
    if (OutCode0 and OutCode1)<> 0 then begin
      result:= true;
      exit;
    end
    else begin
      if OutCode0> 0 then OutCodeOut:= OutCode0
      else OutCodeOut:= OutCode1;

      if (OutCodeOut and CodeBottom)= CodeBottom then begin
        y:= YMax;
        x:= x1+ LongInt(x2- x1)* LongInt(y- y1) div (y2- y1);
      end
      else if (OutCodeOut and CodeTop)= CodeTop then begin
        y:= 0;
        x:= x1+ LongInt(x2- x1)* LongInt(y- y1) div (y2- y1);
      end
      else if (OutCodeOut and CodeRight)= CodeRight then begin
        x:= XMax;
        y:= y1+ LongInt(y2- y1)* LongInt(x- x1) div (x2- x1);
      end
      else if (OutCodeOut and CodeLeft)= CodeLeft then begin
        x:= 0;
        y:= y1+ LongInt(y2- y1)* LongInt(x- x1) div (x2- x1);
      end;

      if (OutCodeOut= OutCode0) then begin
        x1:= x;
        y1:= y;
        OutCode0:= CompOutCode(x1, y1);
      end
      else begin
        x2:= x;
        y2:= y;
        OutCode1:= CompOutCode(x2, y2);
      end;
    end;
  end;
end;

//========================================================
// Pack color
const
  R16 : array [0..255] of Byte= (
    0,     0,     0,     0,     0,     0,     0,     0,     1,     1,     1,     1,     1,     1,     1,     1,
    2,     2,     2,     2,     2,     2,     2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
    4,     4,     4,     4,     4,     4,     4,     4,     5,     5,     5,     5,     5,     5,     5,     5,
    6,     6,     6,     6,     6,     6,     6,     6,     7,     7,     7,     7,     7,     7,     7,     7,
    8,     8,     8,     8,     8,     8,     8,     8,     9,     9,     9,     9,     9,     9,     9,     9,
    10,    10,    10,    10,    10,    10,    10,    10,    11,    11,    11,    11,    11,    11,    11,    11,
    12,    12,    12,    12,    12,    12,    12,    12,    13,    13,    13,    13,    13,    13,    13,    13,
    14,    14,    14,    14,    14,    14,    14,    14,    15,    15,    15,    15,    15,    15,    15,    15,
    16,    16,    16,    16,    16,    16,    16,    16,    17,    17,    17,    17,    17,    17,    17,    17,
    18,    18,    18,    18,    18,    18,    18,    18,    19,    19,    19,    19,    19,    19,    19,    19,
    20,    20,    20,    20,    20,    20,    20,    20,    21,    21,    21,    21,    21,    21,    21,    21,
    22,    22,    22,    22,    22,    22,    22,    22,    23,    23,    23,    23,    23,    23,    23,    23,
    24,    24,    24,    24,    24,    24,    24,    24,    25,    25,    25,    25,    25,    25,    25,    25,
    26,    26,    26,    26,    26,    26,    26,    26,    27,    27,    27,    27,    27,    27,    27,    27,
    28,    28,    28,    28,    28,    28,    28,    28,    29,    29,    29,    29,    29,    29,    29,    29,
    30,    30,    30,    30,    30,    30,    30,    30,    31,    31,    31,    31,    31,    31,    31,    31);

const
  G16 : array [0..255] of Word= (
    0,     0,     0,     0,     32,    32,    32,    32,    64,    64,    64,    64,    96,    96,    96,    96,
    128,   128,   128,   128,   160,   160,   160,   160,   192,   192,   192,   192,   224,   224,   224,   224,
    256,   256,   256,   256,   288,   288,   288,   288,   320,   320,   320,   320,   352,   352,   352,   352,
    384,   384,   384,   384,   416,   416,   416,   416,   448,   448,   448,   448,   480,   480,   480,   480,
    512,   512,   512,   512,   544,   544,   544,   544,   576,   576,   576,   576,   608,   608,   608,   608,
    640,   640,   640,   640,   672,   672,   672,   672,   704,   704,   704,   704,   736,   736,   736,   736,
    768,   768,   768,   768,   800,   800,   800,   800,   832,   832,   832,   832,   864,   864,   864,   864,
    896,   896,   896,   896,   928,   928,   928,   928,   960,   960,   960,   960,   992,   992,   992,   992,
    1024,  1024,  1024,  1024,  1056,  1056,  1056,  1056,  1088,  1088,  1088,  1088,  1120,  1120,  1120,  1120,
    1152,  1152,  1152,  1152,  1184,  1184,  1184,  1184,  1216,  1216,  1216,  1216,  1248,  1248,  1248,  1248,
    1280,  1280,  1280,  1280,  1312,  1312,  1312,  1312,  1344,  1344,  1344,  1344,  1376,  1376,  1376,  1376,
    1408,  1408,  1408,  1408,  1440,  1440,  1440,  1440,  1472,  1472,  1472,  1472,  1504,  1504,  1504,  1504,
    1536,  1536,  1536,  1536,  1568,  1568,  1568,  1568,  1600,  1600,  1600,  1600,  1632,  1632,  1632,  1632,
    1664,  1664,  1664,  1664,  1696,  1696,  1696,  1696,  1728,  1728,  1728,  1728,  1760,  1760,  1760,  1760,
    1792,  1792,  1792,  1792,  1824,  1824,  1824,  1824,  1856,  1856,  1856,  1856,  1888,  1888,  1888,  1888,
    1920,  1920,  1920,  1920,  1952,  1952,  1952,  1952,  1984,  1984,  1984,  1984,  2016,  2016,  2016,  2016);

const
  B16 : array [0..255] of Word= (
    0,     0,     0,     0,     0,     0,     0,     0,     2048,  2048,  2048,  2048,  2048,  2048,  2048,  2048,
    4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,  6144,  6144,  6144,  6144,  6144,  6144,  6144,  6144,
    8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,  10240, 10240, 10240, 10240, 10240, 10240, 10240, 10240,
    12288, 12288, 12288, 12288, 12288, 12288, 12288, 12288, 14336, 14336, 14336, 14336, 14336, 14336, 14336, 14336,
    16384, 16384, 16384, 16384, 16384, 16384, 16384, 16384, 18432, 18432, 18432, 18432, 18432, 18432, 18432, 18432,
    20480, 20480, 20480, 20480, 20480, 20480, 20480, 20480, 22528, 22528, 22528, 22528, 22528, 22528, 22528, 22528,
    24576, 24576, 24576, 24576, 24576, 24576, 24576, 24576, 26624, 26624, 26624, 26624, 26624, 26624, 26624, 26624,
    28672, 28672, 28672, 28672, 28672, 28672, 28672, 28672, 30720, 30720, 30720, 30720, 30720, 30720, 30720, 30720,
    32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768, 34816, 34816, 34816, 34816, 34816, 34816, 34816, 34816,
    36864, 36864, 36864, 36864, 36864, 36864, 36864, 36864, 38912, 38912, 38912, 38912, 38912, 38912, 38912, 38912,
    40960, 40960, 40960, 40960, 40960, 40960, 40960, 40960, 43008, 43008, 43008, 43008, 43008, 43008, 43008, 43008,
    45056, 45056, 45056, 45056, 45056, 45056, 45056, 45056, 47104, 47104, 47104, 47104, 47104, 47104, 47104, 47104,
    49152, 49152, 49152, 49152, 49152, 49152, 49152, 49152, 51200, 51200, 51200, 51200, 51200, 51200, 51200, 51200,
    53248, 53248, 53248, 53248, 53248, 53248, 53248, 53248, 55296, 55296, 55296, 55296, 55296, 55296, 55296, 55296,
    57344, 57344, 57344, 57344, 57344, 57344, 57344, 57344, 59392, 59392, 59392, 59392, 59392, 59392, 59392, 59392,
    61440, 61440, 61440, 61440, 61440, 61440, 61440, 61440, 63488, 63488, 63488, 63488, 63488, 63488, 63488, 63488);

function RGB(R, G, B : Byte) : LongWord;
begin
  case ScreenBpp of
    16 : RGB:= R16[B] or G16[G] or B16[R];
    24 : RGB:= Windows.RGB(B, G, R);
    32 : RGB:= Windows.RGB(B, G, R);
  else
    RGB:= 0;
  end;
end;

//========================================================
// UnPack color
const
  upsample5to8 : array [0..31] of Byte= (
    0,   8,   16,  24,  32,  41,  49,  57,
    65,  74,  82,  90,  98,  106, 115, 123,
    131, 139, 148, 156, 164, 172, 180, 189,
    197, 205, 213, 222, 230, 238, 246, 255);

const
  upsample6to8 : array [0..63] of Byte= (
    0,   4,   8,   12,  16,  20,  24,  28,
    32,  36,  40,  44,  48,  52,  56,  60,
    64,  68,  72,  76,  80,  85,  89,  93,
    97,  101, 105, 109, 113, 117, 121, 125,
    129, 133, 137, 141, 145, 149, 153, 157,
    161, 165, 170, 174, 178, 182, 186, 190,
    194, 198, 202, 206, 210, 214, 218, 222,
    226, 230, 234, 238, 242, 246, 250, 255);

procedure UnRGB(color : LongWord; var R, G, B : Byte);
begin
  case ScreenBpp of
    16 : begin
           R:= upsample5to8[(color shr 11) and $1F];
           G:= upsample6to8[(color shr 5) and $3F];
           B:= upsample5to8[color and $1F];
         end;
    24 : begin
           R:= color shr 16;
           G:= color shr 8;
           B:= color;
         end;
    32 : begin
           R:= color shr 16;
           G:= color shr 8;
           B:= color;
         end;
  end;
end;

/////////// RGB DEPENDANT GFX /////////////

procedure add_line16(src,dst : pline16; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : integer;
  c1, c2 : word;
begin
  for i:= 0 to size- 1 do begin
    c1:= src[s_xi];
    c2:= dst[d_xi];
    r1:= upsample5to8[(c1 shr 11) and $1F];
    g1:= upsample6to8[(c1 shr 5) and $3F];
    b1:= upsample5to8[c1 and $1F];
    r2:= upsample5to8[(c2 shr 11) and $1F];
    g2:= upsample6to8[(c2 shr 5) and $3F];
    b2:= upsample5to8[c2 and $1F];
    r:= r1+ r2; if r> 255 then r:= 255;
    g:= g1+ g2; if g> 255 then g:= 255;
    b:= b1+ b2; if b> 255 then b:= 255;
    dst[d_xi]:= R16[b] or G16[g] or B16[r];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure add_line24(src,dst : pline24; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : integer;
begin
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi].r;
    g1:= src[s_xi].g;
    b1:= src[s_xi].b;
    r2:= dst[d_xi].r;
    g2:= dst[d_xi].g;
    b2:= dst[d_xi].b;
    r:= r1+ r2; if r> 255 then r:= 255;
    g:= g1+ g2; if g> 255 then g:= 255;
    b:= b1+ b2; if b> 255 then b:= 255;
    dst[d_xi].r:= r;
    dst[d_xi].g:= g;
    dst[d_xi].b:= b;
    inc(d_xi);
    inc(s_xi);
  end;
end;

procedure add_line32(src,dst : pline8; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : integer;
begin
  s_xi:= s_xi shl 2;
  d_xi:= d_xi shl 2;
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi];
    g1:= src[s_xi+ 1];
    b1:= src[s_xi+ 2];
    r2:= dst[d_xi];
    g2:= dst[d_xi+ 1];
    b2:= dst[d_xi+ 2];
    r:= r1+ r2; if r> 255 then r:= 255;
    g:= g1+ g2; if g> 255 then g:= 255;
    b:= b1+ b2; if b> 255 then b:= 255;
    dst[d_xi]   := r;
    dst[d_xi+ 1]:= g;
    dst[d_xi+ 2]:= b;
    inc(d_xi, 4);
    inc(s_xi, 4);
  end;
end;

procedure sub_line16(src,dst : pline16; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : integer;
  c1, c2 : word;
begin
  for i:= 0 to size- 1 do begin
    c1:= src[s_xi];
    c2:= dst[d_xi];
    r1:= upsample5to8[(c1 shr 11) and $1F];
    g1:= upsample6to8[(c1 shr 5) and $3F];
    b1:= upsample5to8[c1 and $1F];
    r2:= upsample5to8[(c2 shr 11) and $1F];
    g2:= upsample6to8[(c2 shr 5) and $3F];
    b2:= upsample5to8[c2 and $1F];
    r:= r2- r1; if r< 0 then r:= 0;
    g:= g2- g1; if g< 0 then g:= 0;
    b:= b2- b1; if b< 0 then b:= 0;
    dst[d_xi]:= R16[b] or G16[g] or B16[r];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure sub_line24(src,dst : pline24; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : integer;
begin
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi].r;
    g1:= src[s_xi].g;
    b1:= src[s_xi].b;
    r2:= dst[d_xi].r;
    g2:= dst[d_xi].g;
    b2:= dst[d_xi].b;
    r:= r2- r1; if r< 0 then r:= 0;
    g:= g2- g1; if g< 0 then g:= 0;
    b:= b2- b1; if b< 0 then b:= 0;
    dst[d_xi].r:= r;
    dst[d_xi].g:= g;
    dst[d_xi].b:= b;
    inc(d_xi);
    inc(s_xi);
  end;
end;

procedure sub_line32(src,dst : pline8; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : integer;
begin
  s_xi:= s_xi shl 2;
  d_xi:= d_xi shl 2;
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi];
    g1:= src[s_xi+ 1];
    b1:= src[s_xi+ 2];
    r2:= dst[d_xi];
    g2:= dst[d_xi+ 1];
    b2:= dst[d_xi+ 2];
    r:= r2- r1; if r< 0 then r:= 0;
    g:= g2- g1; if g< 0 then g:= 0;
    b:= b2- b1; if b< 0 then b:= 0;
    dst[d_xi]   := r;
    dst[d_xi+ 1]:= g;
    dst[d_xi+ 2]:= b;
    inc(d_xi, 4);
    inc(s_xi, 4);
  end;
end;

procedure xor_line16(src,dst : pline16; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  c1, c2 : word;
begin
  for i:= 0 to size- 1 do begin
    c1:= src[s_xi];
    c2:= dst[d_xi];
    r1:= upsample5to8[(c1 shr 11) and $1F];
    g1:= upsample6to8[(c1 shr 5) and $3F];
    b1:= upsample5to8[c1 and $1F];
    r2:= upsample5to8[(c2 shr 11) and $1F];
    g2:= upsample6to8[(c2 shr 5) and $3F];
    b2:= upsample5to8[c2 and $1F];
    dst[d_xi]:= R16[b1 xor b2] or G16[g1 xor g2] or B16[r1 xor r2];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure xor_line24(src,dst : pline24; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
begin
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi].r;
    g1:= src[s_xi].g;
    b1:= src[s_xi].b;
    r2:= dst[d_xi].r;
    g2:= dst[d_xi].g;
    b2:= dst[d_xi].b;
    dst[d_xi].r:= r1 xor r2;
    dst[d_xi].g:= g1 xor g2;
    dst[d_xi].b:= b1 xor b2;
    inc(d_xi);
    inc(s_xi);
  end;
end;

procedure xor_line32(src,dst : pline8; size, s_xi, d_xi : longint);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
begin
  s_xi:= s_xi shl 2;
  d_xi:= d_xi shl 2;
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi];
    g1:= src[s_xi+ 1];
    b1:= src[s_xi+ 2];
    r2:= dst[d_xi];
    g2:= dst[d_xi+ 1];
    b2:= dst[d_xi+ 2];
    dst[d_xi]   := r1 xor r2;
    dst[d_xi+ 1]:= g1 xor g2;
    dst[d_xi+ 2]:= b1 xor b2;
    inc(d_xi, 4);
    inc(s_xi, 4);
  end;
end;

procedure alpha_line16(src,dst : pline16; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : longint;
  c1, c2 : word;
begin
  for i:= 0 to size- 1 do begin
    c1:= src[s_xi];
    c2:= dst[d_xi];
    r1:= upsample5to8[(c1 shr 11) and $1F];
    g1:= upsample6to8[(c1 shr 5) and $3F];
    b1:= upsample5to8[c1 and $1F];
    r2:= upsample5to8[(c2 shr 11) and $1F];
    g2:= upsample6to8[(c2 shr 5) and $3F];
    b2:= upsample5to8[c2 and $1F];
    r:= AlphaTable^[r2- r1]+ r1;
    g:= AlphaTable^[g2- g1]+ g1;
    b:= AlphaTable^[b2- b1]+ b1;
    dst[d_xi]:= R16[byte(b)] or G16[byte(g)] or B16[byte(r)];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure alpha_line24(src,dst : pline24; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
begin
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi].r;
    g1:= src[s_xi].g;
    b1:= src[s_xi].b;
    r2:= dst[d_xi].r;
    g2:= dst[d_xi].g;
    b2:= dst[d_xi].b;
    dst[d_xi].r:= AlphaTable^[r2- r1]+ r1;
    dst[d_xi].g:= AlphaTable^[g2- g1]+ g1;
    dst[d_xi].b:= AlphaTable^[b2- b1]+ b1;
    inc(d_xi);
    inc(s_xi);
  end;
end;

procedure alpha_line32(src,dst : pline8; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
begin
  s_xi:= s_xi shl 2;
  d_xi:= d_xi shl 2;
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi];
    g1:= src[s_xi+ 1];
    b1:= src[s_xi+ 2];
    r2:= dst[d_xi];
    g2:= dst[d_xi+ 1];
    b2:= dst[d_xi+ 2];
    dst[d_xi]   := AlphaTable^[r2- r1]+ r1;
    dst[d_xi+ 1]:= AlphaTable^[g2- g1]+ g1;
    dst[d_xi+ 2]:= AlphaTable^[b2- b1]+ b1;
    inc(d_xi, 4);
    inc(s_xi, 4);
  end;
end;

procedure alphamap_line16(src,dst : pline16; size, s_xi, d_xi : longint; Alpha : PLine8);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : longint;
  c1, c2 : word;
begin
  for i:= 0 to size- 1 do begin
    c1:= src[s_xi];
    c2:= dst[d_xi];
    r1:= upsample5to8[(c1 shr 11) and $1F];
    g1:= upsample6to8[(c1 shr 5) and $3F];
    b1:= upsample5to8[c1 and $1F];
    r2:= upsample5to8[(c2 shr 11) and $1F];
    g2:= upsample6to8[(c2 shr 5) and $3F];
    b2:= upsample5to8[c2 and $1F];
    r:= ((r2- r1)* (255- Alpha[i])) shr 8+ r1;
    g:= ((g2- g1)* (255- Alpha[i])) shr 8+ g1;
    b:= ((b2- b1)* (255- Alpha[i])) shr 8+ b1;
    dst[d_xi]:= R16[byte(b)] or G16[byte(g)] or B16[byte(r)];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure alphamap_line24(src,dst : pline24; size, s_xi, d_xi : longint; Alpha : PLine8);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
begin
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi].r;
    g1:= src[s_xi].g;
    b1:= src[s_xi].b;
    r2:= dst[d_xi].r;
    g2:= dst[d_xi].g;
    b2:= dst[d_xi].b;
    dst[d_xi].r:= ((r2- r1)* (255- Alpha[i])) shr 8+ r1;
    dst[d_xi].g:= ((g2- g1)* (255- Alpha[i])) shr 8+ g1;
    dst[d_xi].b:= ((b2- b1)* (255- Alpha[i])) shr 8+ b1;
    inc(d_xi);
    inc(s_xi);
  end;
end;

procedure alphamap_line32(src,dst : pline8; size, s_xi, d_xi : longint; Alpha : PLine8);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
begin
  s_xi:= s_xi shl 2;
  d_xi:= d_xi shl 2;
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi];
    g1:= src[s_xi+ 1];
    b1:= src[s_xi+ 2];
    r2:= dst[d_xi];
    g2:= dst[d_xi+ 1];
    b2:= dst[d_xi+ 2];
    dst[d_xi]   := ((r2- r1)* (255- Alpha[i])) shr 8+ r1;
    dst[d_xi+ 1]:= ((g2- g1)* (255- Alpha[i])) shr 8+ g1;
    dst[d_xi+ 2]:= ((b2- b1)* (255- Alpha[i])) shr 8+ b1;
    inc(d_xi, 4);
    inc(s_xi, 4);
  end;
end;

procedure alphakey_line16(src,dst : pline16; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable; key : longword);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : longint;
  c1, c2 : word;
begin
  for i:= 0 to size- 1 do begin
    c1:= src[s_xi];
    if c1<> key then begin
      c2:= dst[d_xi];
      r1:= upsample5to8[(c1 shr 11) and $1F];
      g1:= upsample6to8[(c1 shr 5) and $3F];
      b1:= upsample5to8[c1 and $1F];
      r2:= upsample5to8[(c2 shr 11) and $1F];
      g2:= upsample6to8[(c2 shr 5) and $3F];
      b2:= upsample5to8[c2 and $1F];
      r:= AlphaTable^[r2- r1]+ r1;
      g:= AlphaTable^[g2- g1]+ g1;
      b:= AlphaTable^[b2- b1]+ b1;
      dst[d_xi]:= R16[byte(b)] or G16[byte(g)] or B16[byte(r)];
    end;
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure alphakey_line24(src,dst : pline24; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable; key : longword);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : byte;
begin
  r:= key shr 16;
  g:= key shr 8;
  b:= key;
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi].r;
    g1:= src[s_xi].g;
    b1:= src[s_xi].b;
    if (r<> r1) or (g<> g1) or (b<> b1) then begin
      r2:= dst[d_xi].r;
      g2:= dst[d_xi].g;
      b2:= dst[d_xi].b;
      dst[d_xi].r:= AlphaTable^[r2- r1]+ r1;
      dst[d_xi].g:= AlphaTable^[g2- g1]+ g1;
      dst[d_xi].b:= AlphaTable^[b2- b1]+ b1;
    end;
    inc(d_xi);
    inc(s_xi);
  end;
end;

procedure alphakey_line32(src,dst : pline8; size, s_xi, d_xi : longint; AlphaTable : PAlphaTable; key : longword);
var
  i : longint;
  r1, g1, b1,
  r2, g2, b2 : byte;
  r, g, b : byte;
begin
  s_xi:= s_xi shl 2;
  d_xi:= d_xi shl 2;
  r:= key shr 16;
  g:= key shr 8;
  b:= key;
  for i:= 0 to size- 1 do begin
    r1:= src[s_xi];
    g1:= src[s_xi+ 1];
    b1:= src[s_xi+ 2];
    if (r<> r1) or (g<> g1) or (b<> b1) then begin
      r2:= dst[d_xi];
      g2:= dst[d_xi+ 1];
      b2:= dst[d_xi+ 2];
      dst[d_xi]   := AlphaTable^[r2- r1]+ r1;
      dst[d_xi+ 1]:= AlphaTable^[g2- g1]+ g1;
      dst[d_xi+ 2]:= AlphaTable^[b2- b1]+ b1;
    end;
    inc(d_xi, 4);
    inc(s_xi, 4);
  end;
end;

procedure extractred_line16(src,dst : pline16; size, s_xi, d_xi : longint);
var i : longint;
begin
  for i:= 0 to size- 1 do begin
    dst[d_xi]:= R16[0] or G16[0] or B16[upsample5to8[(src[s_xi] shr 11) and $1F]];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure extractred_line24(src,dst : pline24; size, s_xi, d_xi : longint);
var i : longint;
begin
  for i:= 0 to size- 1 do begin
    dst[d_xi].r:= src[s_xi].r;
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure extractred_line32(src,dst : pline8; size, s_xi, d_xi : longint);
var i : longint;
begin
  inc(s_xi, 2);
  inc(d_xi, 2);
  for i:= 0 to size- 1 do begin
    dst[d_xi]:= src[s_xi];
    inc(s_xi, 4);
    inc(d_xi, 4);
  end;
end;

procedure extractgreen_line16(src,dst : pline16; size, s_xi, d_xi : longint);
var i : longint;
begin
  for i:= 0 to size- 1 do begin
    dst[d_xi]:= R16[0] or G16[upsample6to8[(src[s_xi] shr 5) and $3F]] or B16[0];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure extractgreen_line24(src,dst : pline24; size, s_xi, d_xi : longint);
var i : longint;
begin
  for i:= 0 to size- 1 do begin
    dst[d_xi].g:= src[s_xi].g;
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure extractgreen_line32(src,dst : pline8; size, s_xi, d_xi : longint);
var i : longint;
begin
  inc(s_xi, 1);
  inc(d_xi, 1);
  for i:= 0 to size- 1 do begin
    dst[d_xi]:= src[s_xi];
    inc(s_xi, 4);
    inc(d_xi, 4);
  end;
end;

procedure extractblue_line16(src,dst : pline16; size, s_xi, d_xi : longint);
var i : longint;
begin
  for i:= 0 to size- 1 do begin
    dst[d_xi]:= R16[upsample5to8[src[s_xi] and $1F]] or G16[0] or B16[0];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure extractblue_line24(src,dst : pline24; size, s_xi, d_xi : longint);
var i : longint;
begin
  for i:= 0 to size- 1 do begin
    dst[d_xi].b:= src[s_xi].b;
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure extractblue_line32(src,dst : pline8; size, s_xi, d_xi : longint);
var i : longint;
begin
  for i:= 0 to size- 1 do begin
    dst[d_xi]:= src[s_xi];
    inc(s_xi, 4);
    inc(d_xi, 4);
  end;
end;

procedure extractalpha_line16(src : PLine8; dst : pline16; size, s_xi, d_xi : longint);
var
  i : longint;
  a : byte;
begin
  for i:= 0 to size- 1 do begin
    a:= src[s_xi];
    dst[d_xi]:= R16[a] or G16[a] or B16[a];
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure extractalpha_line24(src : PLine8; dst : pline24; size, s_xi, d_xi : longint);
var
  i : longint;
  a : byte;
begin
  for i:= 0 to size- 1 do begin
    a:= src[s_xi];
    dst[d_xi].r:= a;
    dst[d_xi].g:= a;
    dst[d_xi].b:= a;
    inc(s_xi);
    inc(d_xi);
  end;
end;

procedure extractalpha_line32(src : PLine8; dst : pline8; size, s_xi, d_xi : longint);
var
  i : longint;
  a : byte;
begin
  for i:= 0 to size- 1 do begin
    a:= src[s_xi];
    dst[d_xi]   := a;
    dst[d_xi+ 1]:= a;
    dst[d_xi+ 2]:= a;
    inc(s_xi);
    inc(d_xi, 4);
  end;
end;

procedure Blur2x_16(Buffer : TBuffer64);
var
  ptr16  : pline16;
  ptr16m : pline16;
  ptr16p : pline16;
  c1, c2, c3, c4 : word;
  r1, g1, b1,
  r2, g2, b2,
  r3, g3, b3,
  r4, g4, b4 : byte;
  x, y, px, py : longint;
begin
  with Buffer do
  for y:= 1 to ymax- 1 do begin
    ptr16:= Lines[y];
    ptr16m:= Lines[y- 1];
    ptr16p:= Lines[y+ 1];
    for x:= 1 to xmax- 1 do begin
      c1:= ptr16m[x];
      c2:= ptr16p[x];
      c3:= ptr16[x- 1];
      c4:= ptr16[x+ 1];

      r1:= upsample5to8[c1 and $1F];
      g1:= upsample6to8[(c1 shr 5) and $3F];
      b1:= upsample5to8[(c1 shr 11) and $1F];

      r2:= upsample5to8[c2 and $1F];
      g2:= upsample6to8[(c2 shr 5) and $3F];
      b2:= upsample5to8[(c2 shr 11) and $1F];

      r3:= upsample5to8[c3 and $1F];
      g3:= upsample6to8[(c3 shr 5) and $3F];
      b3:= upsample5to8[(c3 shr 11) and $1F];

      r4:= upsample5to8[c4 and $1F];
      g4:= upsample6to8[(c4 shr 5) and $3F];
      b4:= upsample5to8[(c4 shr 11) and $1F];

      ptr16[x]:= R16[(r1+ r2+ r3+ r4) shr 2] or
                 G16[(g1+ g2+ g3+ g4) shr 2] or
                 B16[(b1+ b2+ b3+ b4) shr 2];
    end;
  end;
end;

procedure Blur2x_24(Buffer : TBuffer64);
var
  ptr24  : pline24;
  ptr24m : pline24;
  ptr24p : pline24;
  c1_, c2_, c3_, c4_ : TBGR;
  r1, g1, b1,
  r2, g2, b2,
  r3, g3, b3,
  r4, g4, b4 : byte;
  x, y, px, py : longint;
begin
  with Buffer do
  for y:= 1 to ymax- 1 do begin
    ptr24:= Lines[y];
    ptr24m:= Lines[y- 1];
    ptr24p:= Lines[y+ 1];
    for x:= 1 to xmax- 1 do begin
      c1_:= ptr24m[x];
      c2_:= ptr24p[x];
      c3_:= ptr24[x- 1];
      c4_:= ptr24[x+ 1];
      ptr24[x].r:= (c1_.r+ c2_.r+ c3_.r+ c4_.r) shr 2;
      ptr24[x].g:= (c1_.g+ c2_.g+ c3_.g+ c4_.g) shr 2;
      ptr24[x].b:= (c1_.b+ c2_.b+ c3_.b+ c4_.b) shr 2;
    end;
  end;
end;

procedure Blur2x_32(Buffer : TBuffer64);
var
  ptr32 : pline8;
  ptr32m : pline8;
  ptr32p : pline8;
  c1, c2, c3, c4 : longword;
  r1, g1, b1,
  r2, g2, b2,
  r3, g3, b3,
  r4, g4, b4 : byte;
  x, y, px, py : longint;
begin
  with Buffer do
  for y:= 1 to ymax- 1 do begin
    ptr32:= Lines[y];
    ptr32m:= Lines[y- 1];
    ptr32p:= Lines[y+ 1];
    px:= 4;
    for x:= 1 to xmax- 1 do begin
      r1:= ptr32m[px];
      g1:= ptr32m[px+ 1];
      b1:= ptr32m[px+ 2];

      r2:= ptr32p[px];
      g2:= ptr32p[px+ 1];
      b2:= ptr32p[px+ 2];

      r3:= ptr32[px- 4];
      g3:= ptr32[px- 3];
      b3:= ptr32[px- 2];

      r4:= ptr32[px+ 4];
      g4:= ptr32[px+ 5];
      b4:= ptr32[px+ 6];

      ptr32[px]   := (r1+ r2+ r3+ r4) shr 2;
      ptr32[px+ 1]:= (g1+ g2+ g3+ g4) shr 2;
      ptr32[px+ 2]:= (b1+ b2+ b3+ b4) shr 2;
      inc(px, 4)
    end;
  end;
end;

procedure Negative_16(Buffer : TBuffer64);
var
  ptr16 : pline16;
  x, y : longint;
  c : word;
  r, g, b : byte;
begin
  with Buffer do
  for y:= 0 to ysize- 1 do begin
    ptr16:= Lines[y];
    for x:= 0 to xsize- 1 do begin
      c:= ptr16[x];
      r:= upsample5to8[c and $1F];
      g:= upsample6to8[(c shr 5) and $3F];
      b:= upsample5to8[(c shr 11) and $1F];
      ptr16[x]:= R16[255- r] or G16[255- g] or B16[255- b];
    end;
  end;
end;

procedure Negative_24(Buffer : TBuffer64);
var
  ptr24 : pline24;
  c : TBGR;
  r, g, b : byte;
  x, y : longint;
begin
  with Buffer do
  for y:= 0 to ysize- 1 do begin
    ptr24:= Lines[y];
    for x:= 0 to xsize- 1 do begin
      c:= ptr24[x];
      ptr24[x].r:= 255- c.r;
      ptr24[x].g:= 255- c.g;
      ptr24[x].b:= 255- c.b;
    end;
  end;
end;

procedure Negative_32(Buffer : TBuffer64);
var
  ptr32 : pline8;
  c : longword;
  r, g, b : byte;
  x, y, px : longint;
begin
  with Buffer do
  for y:= 0 to ysize- 1 do begin
    ptr32:= Lines[y];
    px:= 0;
    for x:= 0 to xsize- 1 do begin
      r:= ptr32[px];
      g:= ptr32[px+ 1];
      b:= ptr32[px+ 2];

      ptr32[px]   := 255- r;
      ptr32[px+ 1]:= 255- g;
      ptr32[px+ 2]:= 255- b;
      inc(px, 4)
    end;
  end;
end;

procedure Greyscale_16(Buffer : TBuffer64);
var
  ptr16 : pline16;
  x, y : longint;
  c : word;
  r, g, b, l : byte;
begin
  with Buffer do
  for y:= 0 to ysize- 1 do begin
    ptr16:= Lines[y];
    for x:= 0 to xsize- 1 do begin
      c:= ptr16[x];
      r:= upsample5to8[c and $1F];
      g:= upsample6to8[(c shr 5) and $3F];
      b:= upsample5to8[(c shr 11) and $1F];
      l:= (r+ g+ b) div 3;
      ptr16[x]:= R16[l] or G16[l] or B16[l];
    end;
  end;
end;

procedure Greyscale_24(Buffer : TBuffer64);
var
  ptr24 : pline24;
  c : TBGR;
  r, g, b, l : byte;
  x, y : longint;
begin
  with Buffer do
  for y:= 0 to ysize- 1 do begin
    ptr24:= Lines[y];
    for x:= 0 to xsize- 1 do begin
      c:= ptr24[x];
      l:= (c.r+ c.g+ c.b) div 3;
      ptr24[x].r:= l;
      ptr24[x].g:= l;
      ptr24[x].b:= l;
    end;
  end;
end;

procedure Greyscale_32(Buffer : TBuffer64);
var
  ptr32 : pline8;
  c : longword;
  r, g, b, l : byte;
  x, y, px, py : longint;
begin
  with Buffer do
  for y:= 0 to ysize- 1 do begin
    ptr32:= Lines[y];
    px:= 0;
    for x:= 0 to xsize- 1 do begin
      r:= ptr32[px];
      g:= ptr32[px+ 1];
      b:= ptr32[px+ 2];
      l:= (r+ g+ b) div 3;
      ptr32[px]   := l;
      ptr32[px+ 1]:= l;
      ptr32[px+ 2]:= l;
      inc(px, 4)
    end;
  end;
end;

end.

{
  - History Starts at 30th September 2000 -

   # Beta 1, Hyper64v0.1 is released #
   - First
    .Added DrawBit, DrawBitSprite;
    .Added CopyBit, CopyBitSprite;
    .Added TFullHyper64 for FullScreen Modes;
    .Fixed clipping bug in all Draw and Copy funcs;
    .Hyper64 now allocates system memory buffers,
     in case of lack of video memory;
    .Added T****Hyper64 and TBuffer64 XMid and YMid,
     as the center point of the buffer/display;
    .Improved FullScreen Refreshing control;
    .Added TSelfHyper64, runs without the need for a window
     leaving the WinAPI control to Hyper64 reducing the
     program size;
    .Fixed BUG on TTimer64.Time func, returned always zero
     when not running, thanks to HybRid-2k;
    .Fixed LoadImage and GetImageInfo error handling;
    .Added Mouse support to TSelfHyper64;
   - Latest
   # Beta 2, Hyper64v0.2 is released #
   - First
    .Moved TSelfHyper64.DoEvents to THyper64.DoEvents;
    .Improved error control;
    .Made Handle : HWnd, public;
    .TSelfHyper64 now works with windows;
    .Added TSelfFullHyper64 to handle Full Screen display;
    .Renamed Time Format sf*** constants to tf***;
    .Rewritten ClipLine, works fine now;
    .Fixed error on Error control, now returns to desktop
     mode everytime there's an error;  
    .Changed all Real's to Single's, C++ compatibility with Float;
    .Fixed THyper64.DoEvents;
    .Added TBuffer64.CopyAdd;
    .Added TBuffer64.CopySub;
    .Added TBuffer64.CopyXor;
    .Added TBuffer64.CopyAlpha;
    .Added TBuffer64.Blur2x;
    .Fixed TBuffer64.CopySub;
    .Improved WinAPI concerning Window control;
    .Fixed TSelfHyper64, the windows had the wrong size;
    .Removed Surface Restore error checks, now
     fullscreen windows can be minimized and maximized
     without problems;
    .Added multiple TSelfHyper64 support;
    .Changed TBuffer64.Draw, now uses blit instead
     of flip because of VSync in some boards;
   - Latest
   # Beta 3, Hyper64v0.3 is released #
   - First
    .Added CopyAlphaSprite;
    .Fixed all ****Bit and ****BitSprite
     funcs, now draws independantly of the
     x1/y1/x2/y2 order;
    .Added TBuffer64.Alpha[ysize][xsize], so you can
     have free access to the alpha channel for realtime
     changes, used in CopyAlphaMap
    .Added TBuffer64.LoadAlpha to load a 256 color
     image to TBuffer64.Alpha, CopyAlphaMap will use each
     color as alpha intensity for each pixel of the buffer;
    .Added TBuffer64.Negative filter;
    .Added TBuffer64.Greyscale filter;
    .Added TBuffer64.CopyRedChannel to extract
     the red component;
    .Added TBuffer64.CopyGreenChannel to extract
     the green component;
    .Added TBuffer64.CopyBlueChannel to extract
     the blue component;
    .Added TBuffer64.CopyAlphaChannel to extract
     the alpha component (if available);
    .Fixed WinAPI for multiple windows, now only the
     selected window will close;
    .Improved T***Hyper.DoEvents, now always returns
     false if the class was destroyed;
    .Removed Alpha array and added
     AlphaPtr, AlphaLines and AlphaPixels;
    .Added H64_VERSION, $B0x is for Beta Versions and
     $00x for complete versions;
    .Fixed TBuffer64.GetImageSize;
   - Latest
   # Beta 4, Hyper64v0.4 is released #
   - First
   - Latest
}
